
/* DO NOT EDIT. Automatically generated by valabind from r_asm */

var ffi = require('ffi'), ref = require('ref'), Struct = require('ref-struct');
var lib = new ffi.DynamicLibrary('libr_asm'+ffi.LIB_EXT);

function Tname(T) {
	return T.hasOwnProperty('$name') ? T.$name : T.name;
}

var types = exports.type = {};

for(var i in ref.types)
	if(i != 'Utf8String') // Try not to trip the deprecated warning.
		types[i] = ref.types[i];

types.staticCString = function staticCString(N) {
	var r = Object.create(types.char);
	r.name = 'char['+N+']';
	r.size *= N;
	r.get = function get(buf, offset) {
		if(buf.isNull())
			return null;
		// TODO enforce maxLength of N
		return buf.readCString(offset);
	};
	r.set = function set(buf, offset, val) {
		// TODO enforce maxLength of N
		return buf.writeCString(val, offset);
	};
	return r;
};

var ptrCache = [], ptrCacheTo = [];
types.ptr = function PointerType(T) {
	T = ref.coerceType(T);
	if(T == types.char)
		return types.CString;
	var i = ptrCache.indexOf(T);
	return i === -1 ? ptrCacheTo[ptrCache.push(T)-1] = ref.refType(T) : ptrCacheTo[i];
};

var refCache = [], refCacheTo = [];
types.ref = function ReferenceType(T) {
	T = ref.coerceType(T);
	var i = refCache.indexOf(T);
	if(i !== -1)
		return refCacheTo[i];
	var p = types.ptr(T), r = refCacheTo[refCache.push(T)-1] = Object.create(p);
	r.indirection = 1;
	r.size = ref.sizeof.pointer;
	r.alignment = ref.alignof.pointer;
	r.name = Tname(T)+'&';
	r.ffi_type = ffi.FFI_TYPES.pointer;
	r.get = function get(buf, offset) {
		buf = ref.get(buf, offset, p);
		if(buf.isNull())
			return null;
		return buf.deref();
	};
	r.set = function set(buf, offset, val) {
		if(!val)
			return ref.set(buf, offset, null, p);
		if(!val.buffer)
			throw new TypeError('valabind ['+r.name+']#set got a bad value');
		return ref.set(buf, offset, val.buffer, p);
	};
	return r;
};

types.array = function ArrayType(T, N) {
	T = ref.coerceType(T);
	if(T == types.char)
		return types.staticCString(N);
	var r = Object.create(T);
	r.size *= N;
	r.name = Tname(T)+'['+N+']';
	function ArrayType(buffer, base) {
		this.buffer = buffer;
		this._base = base;
	}
	ArrayType.prototype = [];
	ArrayType.prototype.constructor = ArrayType;
	for(var i = 0; i < N; i++)
		Object.defineProperty(ArrayType.prototype, i, {
			get: function get() {
				return ref.get(this.buffer, this._base+T.size*i, T);
			},
			set: function set(val) {
				return ref.set(this.buffer, this._base+T.size*i, val, T);
			},
			enumerable: true
		});
	r.get = function get(buf, offset) {
		return new ArrayType(buf, offset);
	};
	r.set = function set(buf, offset, val) {
		for(var i in val) {
			if(isNaN(i = +i) || i >= N)
				continue;
			ref.set(buf, offset+T.size*i, val[i], T);
		}
	};
	return r;
};

types.delegate = function DelegateType(ret, args) {
	var p = types.ptr(types.void), r = Object.create(p);
	r.indirection = 1;
	r.name = Tname(ret)+'('+args.map(function(T) {return Tname(T);}).join(', ')+')';
	r.get = function get(buf, offset) {
		buf = ref.get(buf, offset, p);
		if(buf.isNull())
			return null;
		return ffi.ForeignFunction(buf, ret, args);
	};
	r.set = function set(buf, offset, val) {
		return ref.set(buf, offset, ffi.Callback(ret, args, void(0), val));
	};
	return r;
};

var defaults = {
	forEach: function forEach(callback, thisArg) {
		if({}.toString.call(callback) != '[object Function]')
			throw new TypeError(callback + ' is not a function');

		for(var T = thisArg || T, iter = this.iterator(); iter; iter = iter.get_next())
			callback.call(T, iter.get_data(), iter, this);
	}
};

function bindings(s) {
	function method(name, ret, args, static, more) {
		var f = (more == 'variadic' ? ffi.VariadicForeignFunction :
			ffi.ForeignFunction)(lib.get(name), ret, args);
		if(static)
			return f;
		return function() {
			[].unshift.call(arguments, this);
			return f.apply(null, arguments);
		};
	}

	function define(base, n, m) {
		var static = n[0] == '$' && ((n = n.slice(1)), true);
		static = static || base[0] == '$' && ((base = base.slice(1)), true);
		if(Array.isArray(m))
			m = method(m[0], m[1], m[2], static, m[3]);
		static ? exports[base][n] = m : types[base].prototype[n] = m;
	}

	function makeGeneric(G, n) {
		var cache = [], cacheTo = [];
		types[n] = function() {
			var l = arguments.length, args = [], c;

			// Coerce all type arguments.
			for(var i = 0; i < l; i++)
				args[i] = ref.coerceType(arguments[i].$type || arguments[i]);

			// Look in the cache, if the generic was already built.
			for(var i = 0; i < cache.length; i++) {
				if((c = cache[i]).length !== l)
					continue;
				for(var j = 0; j < l && c[j] === args[j]; j++);
				if(j === l)
					return cacheTo[i];
			}

			// Create the new generic.
			var generic = cacheTo[cache.push(args)-1] = Struct(), g = G.apply(null, args);
			generic.$name = n+'<'+args.map(function(T) {return Tname(T);}).join(', ')+'>';

			// Define all the generic's propoerties.
			for(var i in g[0])
				generic.defineProperty(i, g[0][i]);

			// Insert all the generic's methods.
			if(g[1])
				for(var i in g[1]) {
					var m = g[1][i];
					if(Array.isArray(m))
						m = method(m[0], m[1], m[2], false, m[3]);
					generic.prototype[i] = m;
				}
			return generic;
		};
	}
	for(var i in s) {
		if(s[i].length)
			makeGeneric(s[i], i);
		else if(i[0] == '$')
			exports[i.slice(1)] = {};
		else
			exports[i] = types[i] = Struct(), types[i].$name = i;
	}
	for(var i in s) {
		if(s[i].length) {
			// TODO insert constructor
			delete s[i];
			continue;
		}
		s[i] = s[i]();
		if(Array.isArray(s[i])) {
			for(var j in s[i][0])
				types[i].defineProperty(j, s[i][0][j]);
			s[i] = s[i][1];
		}
	}
	for(var i in s) {
		if('$constructor' in s[i]) {
			var ctor = s[i].$constructor;
			exports[i] = method(ctor[0], ctor[1], ctor[2], true, ctor[3]), exports[i].$type = types[i];
			delete s[i].$constructor;
		}
		for(var j in s[i])
			define(i, j, s[i][j]);
	}
}
var _ = types;
bindings({
	$RStr: function() {return {
		rwx_i: ['r_str_rwx_i', _.CString, [_.int]],
		hash: ['r_str_hash', _.int, [_.CString]],
		write: ['r_str_write', _.int, [_.int, _.CString]],
		rwx: ['r_str_rwx', _.int, [_.CString]],
		replace_char: ['r_str_replace_char', _.int, [_.CString, _.int, _.int]],
		ansi_len: ['r_str_ansi_len', _.int, [_.CString]],
		ansi_filter: ['r_str_ansi_filter', _.int, [_.CString, _.int]]
	};},
	$RFile: function() {return {
		rm: ['r_file_rm', _.bool, [_.CString]],
		tmpdir: ['r_file_tmpdir', _.CString, []],
		temp: ['r_file_temp', _.CString, [_.CString]],
		slurp: ['r_file_slurp', _.CString, [_.CString, _.int]],
		slurp_range: ['r_file_slurp_range', _.CString, [_.CString, _.uint64, _.int, _.int]],
		dump: ['r_file_dump', _.int, [_.CString, _.ptr(_.uint8), _.int]],
		basename: ['r_file_basename', _.CString, [_.CString]],
		abspath: ['r_file_abspath', _.CString, [_.CString]],
		exists: ['r_file_exists', _.bool, [_.CString]],
		slurp_line: ['r_file_slurp_line', _.bool, [_.CString, _.int, _.int]]
	};},
	$RLog: function() {return {
		msg: ['r_log_msg', _.void, [_.CString]],
		error: ['r_log_error', _.void, [_.CString]],
		file: ['r_log_file', _.void, [_.CString]],
		progress: ['r_log_progress', _.void, [_.CString, _.int]]
	};},
	$RHex: function() {return {
		str2bin: ['r_hex_str2bin', _.int, [_.CString, _.ptr(_.uint8)]],
		bin2str: ['r_hex_bin2str', _.int, [_.ptr(_.uint8), _.int, _.CString]],
		bin2strdup: ['r_hex_bin2strdup', _.CString, [_.ptr(_.uint8), _.int]]
	};},
	$RSystem: function() {return {
		sleep: ['r_sys_sleep', _.int, [_.int]],
		usleep: ['r_sys_usleep', _.int, [_.int]],
		getenv: ['r_sys_getenv', _.CString, [_.CString]],
		setenv: ['r_sys_setenv', _.bool, [_.CString, _.CString]],
		cmd: ['r_sys_cmd', _.int, [_.CString]],
		cmd_str: ['r_sys_cmd_str', _.CString, [_.CString, _.CString, _.int]],
		backtrace: ['r_sys_backtrace', _.void, []]
	};},
	RLibStruct: function() {return [{
		type: _.int,
		data: _.ptr(_.void)
	}, {}];},
	RAsmOp: function() {return [{
		size: _.int,
		payload: _.int,
		buf: _.array(_.uint8, 1024),
		buf_asm: _.array(_.char, 1024),
		buf_hex: _.array(_.char, 1024),
		buf_err: _.array(_.char, 1024)
	}, {
		get_hex: ['r_asm_op_get_hex', _.CString, [_.RAsmOp]],
		get_asm: ['r_asm_op_get_asm', _.CString, [_.RAsmOp]]
	}];},
	RAsmCode: function() {return [{
		len: _.int,
		buf: _.ptr(_.uint8),
		buf_hex: _.CString,
		buf_asm: _.CString
	}, {
		delete: ['r_asm_code_free', _.void, [_.ref(_.RAsmCode)]]
	}];},
	RAsmPlugin: function() {return [{
		name: _.CString,
		arch: _.CString,
		desc: _.CString,
		license: _.CString,
		bits: _.int
	}, {}];},
	RAsm: function() {return [{
		bits: _.int,
		big_endian: _.bool,
		syntax: _.int,
		pc: _.uint64,
		plugins: _.ref(_.RList(_.ref(_.RAsmPlugin)))
	}, {
		$Arch: {}/*types.Enum*/,
		$Syntax: {}/*types.Enum*/,
		$Mod: {}/*types.Enum*/,
		delete: ['r_asm_free', _.void, [_.ref(_.RAsm)]],
		$constructor: ['r_asm_new', _.ref(_.RAsm), []],
		use: ['r_asm_use', _.bool, [_.ref(_.RAsm), _.CString]],
		set_bits: ['r_asm_set_bits', _.bool, [_.ref(_.RAsm), _.int]],
		set_syntax: ['r_asm_set_syntax', _.bool, [_.ref(_.RAsm), _.int]],
		set_pc: ['r_asm_set_pc', _.bool, [_.ref(_.RAsm), _.uint64]],
		set_big_endian: ['r_asm_set_big_endian', _.bool, [_.ref(_.RAsm), _.bool]],
		disassemble: ['r_asm_disassemble', _.int, [_.ref(_.RAsm), _.RAsmOp, _.ptr(_.uint8), _.int]],
		assemble: ['r_asm_assemble', _.int, [_.ref(_.RAsm), _.RAsmOp, _.CString]],
		mdisassemble: ['r_asm_mdisassemble', _.ref(_.RAsmCode), [_.ref(_.RAsm), _.ptr(_.uint8), _.int]],
		mdisassemble_hexstr: ['r_asm_mdisassemble_hexstr', _.ref(_.RAsmCode), [_.ref(_.RAsm), _.CString]],
		massemble: ['r_asm_massemble', _.ref(_.RAsmCode), [_.ref(_.RAsm), _.CString]],
		assemble_file: ['r_asm_assemble_file', _.ref(_.RAsmCode), [_.ref(_.RAsm), _.CString]],
		filter_input: ['r_asm_filter_input', _.bool, [_.ref(_.RAsm), _.CString]],
		filter_output: ['r_asm_filter_output', _.bool, [_.ref(_.RAsm), _.CString]],
		free: ['r_asm_free', _.void, [_.ref(_.RAsm)]]
	}];},
	RStrBuf: function() {return [{}, {
		delete: ['r_strbuf_free', _.void, [_.ref(_.RStrBuf)]],
		$constructor: ['r_strbuf_new', _.ref(_.RStrBuf), [_.CString]],
		set: ['r_strbuf_set', _.bool, [_.ref(_.RStrBuf), _.CString]],
		setf: ['r_strbuf_setf', _.bool, [_.ref(_.RStrBuf), _.CString], 'variadic'],
		append: ['r_strbuf_append', _.bool, [_.ref(_.RStrBuf), _.CString]],
		get: ['r_strbuf_get', _.CString, [_.ref(_.RStrBuf)]]
	}];},
	RNum: function() {return [{}, {
		$constructor: ['r_num_new', _.ref(_.RNum), [_.delegate(_.uint64, [_.CString, _.ptr(_.int)]), _.ptr(_.void)]],
		get: ['r_num_get', _.uint64, [_.ref(_.RNum), _.CString]],
		math: ['r_num_math', _.uint64, [_.ref(_.RNum), _.CString]]
	}];},
	RBuffer: function() {return [{
		buf: _.ptr(_.uint8),
		length: _.int,
		cur: _.int,
		base: _.uint64
	}, {
		delete: ['r_buf_free', _.void, [_.ref(_.RBuffer)]],
		$constructor: ['r_buf_new', _.ref(_.RBuffer), []],
		read_at: ['r_buf_read_at', _.int, [_.ref(_.RBuffer), _.uint64, _.ptr(_.uint8), _.int]],
		write_at: ['r_buf_write_at', _.int, [_.ref(_.RBuffer), _.uint64, _.ptr(_.uint8), _.int]],
		set_bytes: ['r_buf_set_bytes', _.bool, [_.ref(_.RBuffer), _.ptr(_.uint8), _.int]]
	}];},
	RList: function(G) {return [{
		head: _.ptr(_.RListIter(G)),
		tail: _.ptr(_.RListIter(G))
	}, {
		delete: ['r_list_free', _.void, [_.ref(_.RList(G))]],
		append: ['r_list_append', _.void, [_.ref(_.RList(G)), G]],
		prepend: ['r_list_prepend', _.void, [_.ref(_.RList(G)), G]],
		iterator: ['r_list_iterator', _.ref(_.RListIter(G)), [_.ref(_.RList(G))]],
		forEach: defaults.forEach,
		$constructor: ['r_list_new', _.ref(_.RList(G)), []],
		length: ['r_list_length', _.int, [_.ref(_.RList(G))]],
		del_n: ['r_list_del_n', _.bool, [_.ref(_.RList(G)), _.int]],
		get_top: ['r_list_get_top', _.bool, [_.ref(_.RList(G))]],
		pop: ['r_list_pop', G, [_.ref(_.RList(G))]]
	}];},
	RListIter: function(G) {return [{
		data: G,
		n: _.ref(_.RListIter(G)),
		p: _.ref(_.RListIter(G))
	}, {
		delete: ['r_list_iter_free', _.void, [_.ref(_.RListIter(G))]],
		get_data: ['r_list_iter_get_data', G, [_.ref(_.RListIter(G))]],
		get_next: ['r_list_iter_get_next', _.ref(_.RListIter(G)), [_.ref(_.RListIter(G))]]
	}];},
	RRangeItem: function() {return [{
		fr: _.uint64,
		to: _.uint64,
		data: _.ptr(_.uint8),
		datalen: _.int
	}, {}];},
	RRange: function() {return [{}, {
		delete: ['r_range_free', _.void, [_.ref(_.RRange)]],
		$constructor: ['r_range_new', _.ref(_.RRange), []],
		$constructor: ['r_range_new_from_string', _.ref(_.RRange), [_.CString]],
		item_get: ['r_range_item_get', _.ptr(_.RRangeItem), [_.ref(_.RRange), _.uint64]],
		size: ['r_range_size', _.uint64, [_.ref(_.RRange)]],
		add_from_string: ['r_range_add_from_string', _.uint64, [_.ref(_.RRange), _.CString]],
		contains: ['r_range_contains', _.bool, [_.ref(_.RRange), _.uint64]],
		sort: ['r_range_sort', _.bool, [_.ref(_.RRange)]],
		list: ['r_range_list', _.bool, [_.ref(_.RRange), _.bool]],
		get_n: ['r_range_get_n', _.bool, [_.ref(_.RRange), _.int, _.uint64, _.uint64]],
		inverse: ['r_range_inverse', _.ptr(_.RRange), [_.ref(_.RRange), _.uint64, _.uint64, _.int]]
	}];},
	RLib: function() {return [{}, {
		delete: ['r_lib_free', _.void, [_.ref(_.RLib)]],
		$constructor: ['r_lib_new', _.ref(_.RLib), [_.CString]],
		close: ['r_lib_close', _.bool, [_.ref(_.RLib), _.CString]],
		opendir: ['r_lib_opendir', _.int, [_.ref(_.RLib), _.CString]],
		$path: ['r_lib_path', _.CString, [_.CString]],
		$dl_open: ['r_lib_dl_open', _.ptr(_.void), [_.CString]],
		dl_sym: ['r_lib_dl_sym', _.ptr(_.void), [_.ref(_.RLib), _.CString]],
		$dl_close: ['r_lib_dl_close', _.bool, [_.ptr(_.void)]],
		$dl_check_filename: ['r_lib_dl_check_filename', _.bool, [_.CString]],
		del_handler: ['r_lib_del_handler', _.bool, [_.ref(_.RLib), _.int]]
	}];}
});
exports.RLibType = {}/*types.Enum*/;
exports.RLibType.IO = 0;
exports.RLibType.DBG = 1;
exports.RLibType.LANG = 2;
exports.RLibType.ASM = 3;
exports.RLibType.ANAL = 4;
exports.RLibType.PARSE = 5;
exports.RLibType.BIN = 6;
exports.RLibType.BP = 8;
exports.RLibType.SYSCALL = 9;
exports.RLibType.FASTCALL = 10;
exports.RLibType.CRYPTO = 11;
exports.RLibType.CMD = 12;
exports.RLibType.LAST = 14;
exports.RAsm.Arch.NONE = 0;
exports.RAsm.Arch.X86 = 1;
exports.RAsm.Arch.ARM = 2;
exports.RAsm.Arch.PPC = 4;
exports.RAsm.Arch.M68K = 8;
exports.RAsm.Arch.JAVA = 16;
exports.RAsm.Arch.MIPS = 32;
exports.RAsm.Arch.SPARC = 64;
exports.RAsm.Arch.CSR = 128;
exports.RAsm.Arch.MSIL = 256;
exports.RAsm.Arch.OBJD = 512;
exports.RAsm.Arch.BF = 1024;
exports.RAsm.Arch.SH = 2048;
exports.RAsm.Arch.Z80 = 16384;
exports.RAsm.Arch.I8080 = 65536;
exports.RAsm.Arch.ARC = 32768;
exports.RAsm.Syntax.NONE = 0;
exports.RAsm.Syntax.INTEL = 1;
exports.RAsm.Syntax.ATT = 2;
exports.RAsm.Mod.RAWVALUE = 114;
exports.RAsm.Mod.VALUE = 118;
exports.RAsm.Mod.DSTREG = 100;
exports.RAsm.Mod.SRCREG0 = 48;
exports.RAsm.Mod.SRCREG1 = 49;
exports.RAsm.Mod.SRCREG2 = 50;
