
/* DO NOT EDIT. Automatically generated by valabind from r_bin */

var ffi = require('ffi'), ref = require('ref'), Struct = require('ref-struct');
var lib = new ffi.DynamicLibrary('libr_bin'+ffi.LIB_EXT);

function Tname(T) {
	return T.hasOwnProperty('$name') ? T.$name : T.name;
}

var types = exports.type = {};

for(var i in ref.types)
	if(i != 'Utf8String') // Try not to trip the deprecated warning.
		types[i] = ref.types[i];

types.staticCString = function staticCString(N) {
	var r = Object.create(types.char);
	r.name = 'char['+N+']';
	r.size *= N;
	r.get = function get(buf, offset) {
		if(buf.isNull())
			return null;
		// TODO enforce maxLength of N
		return buf.readCString(offset);
	};
	r.set = function set(buf, offset, val) {
		// TODO enforce maxLength of N
		return buf.writeCString(val, offset);
	};
	return r;
};

var ptrCache = [], ptrCacheTo = [];
types.ptr = function PointerType(T) {
	T = ref.coerceType(T);
	if(T == types.char)
		return types.CString;
	var i = ptrCache.indexOf(T);
	return i === -1 ? ptrCacheTo[ptrCache.push(T)-1] = ref.refType(T) : ptrCacheTo[i];
};

var refCache = [], refCacheTo = [];
types.ref = function ReferenceType(T) {
	T = ref.coerceType(T);
	var i = refCache.indexOf(T);
	if(i !== -1)
		return refCacheTo[i];
	var p = types.ptr(T), r = refCacheTo[refCache.push(T)-1] = Object.create(p);
	r.indirection = 1;
	r.size = ref.sizeof.pointer;
	r.alignment = ref.alignof.pointer;
	r.name = Tname(T)+'&';
	r.ffi_type = ffi.FFI_TYPES.pointer;
	r.get = function get(buf, offset) {
		buf = ref.get(buf, offset, p);
		if(buf.isNull())
			return null;
		return buf.deref();
	};
	r.set = function set(buf, offset, val) {
		if(!val)
			return ref.set(buf, offset, null, p);
		if(!val.buffer)
			throw new TypeError('valabind ['+r.name+']#set got a bad value');
		return ref.set(buf, offset, val.buffer, p);
	};
	return r;
};

types.array = function ArrayType(T, N) {
	T = ref.coerceType(T);
	if(T == types.char)
		return types.staticCString(N);
	var r = Object.create(T);
	r.size *= N;
	r.name = Tname(T)+'['+N+']';
	function ArrayType(buffer, base) {
		this.buffer = buffer;
		this._base = base;
	}
	ArrayType.prototype = [];
	ArrayType.prototype.constructor = ArrayType;
	for(var i = 0; i < N; i++)
		Object.defineProperty(ArrayType.prototype, i, {
			get: function get() {
				return ref.get(this.buffer, this._base+T.size*i, T);
			},
			set: function set(val) {
				return ref.set(this.buffer, this._base+T.size*i, val, T);
			},
			enumerable: true
		});
	r.get = function get(buf, offset) {
		return new ArrayType(buf, offset);
	};
	r.set = function set(buf, offset, val) {
		for(var i in val) {
			if(isNaN(i = +i) || i >= N)
				continue;
			ref.set(buf, offset+T.size*i, val[i], T);
		}
	};
	return r;
};

types.delegate = function DelegateType(ret, args) {
	var p = types.ptr(types.void), r = Object.create(p);
	r.indirection = 1;
	r.name = Tname(ret)+'('+args.map(function(T) {return Tname(T);}).join(', ')+')';
	r.get = function get(buf, offset) {
		buf = ref.get(buf, offset, p);
		if(buf.isNull())
			return null;
		return ffi.ForeignFunction(buf, ret, args);
	};
	r.set = function set(buf, offset, val) {
		return ref.set(buf, offset, ffi.Callback(ret, args, void(0), val));
	};
	return r;
};

var defaults = {
	forEach: function forEach(callback, thisArg) {
		if({}.toString.call(callback) != '[object Function]')
			throw new TypeError(callback + ' is not a function');

		for(var T = thisArg || T, iter = this.iterator(); iter; iter = iter.get_next())
			callback.call(T, iter.get_data(), iter, this);
	}
};

function bindings(s) {
	function method(name, ret, args, static, more) {
		var f = (more == 'variadic' ? ffi.VariadicForeignFunction :
			ffi.ForeignFunction)(lib.get(name), ret, args);
		if(static)
			return f;
		return function() {
			[].unshift.call(arguments, this);
			return f.apply(null, arguments);
		};
	}

	function define(base, n, m) {
		var static = n[0] == '$' && ((n = n.slice(1)), true);
		static = static || base[0] == '$' && ((base = base.slice(1)), true);
		if(Array.isArray(m))
			m = method(m[0], m[1], m[2], static, m[3]);
		static ? exports[base][n] = m : types[base].prototype[n] = m;
	}

	function makeGeneric(G, n) {
		var cache = [], cacheTo = [];
		types[n] = function() {
			var l = arguments.length, args = [], c;

			// Coerce all type arguments.
			for(var i = 0; i < l; i++)
				args[i] = ref.coerceType(arguments[i].$type || arguments[i]);

			// Look in the cache, if the generic was already built.
			for(var i = 0; i < cache.length; i++) {
				if((c = cache[i]).length !== l)
					continue;
				for(var j = 0; j < l && c[j] === args[j]; j++);
				if(j === l)
					return cacheTo[i];
			}

			// Create the new generic.
			var generic = cacheTo[cache.push(args)-1] = Struct(), g = G.apply(null, args);
			generic.$name = n+'<'+args.map(function(T) {return Tname(T);}).join(', ')+'>';

			// Define all the generic's propoerties.
			for(var i in g[0])
				generic.defineProperty(i, g[0][i]);

			// Insert all the generic's methods.
			if(g[1])
				for(var i in g[1]) {
					var m = g[1][i];
					if(Array.isArray(m))
						m = method(m[0], m[1], m[2], false, m[3]);
					generic.prototype[i] = m;
				}
			return generic;
		};
	}
	for(var i in s) {
		if(s[i].length)
			makeGeneric(s[i], i);
		else if(i[0] == '$')
			exports[i.slice(1)] = {};
		else
			exports[i] = types[i] = Struct(), types[i].$name = i;
	}
	for(var i in s) {
		if(s[i].length) {
			// TODO insert constructor
			delete s[i];
			continue;
		}
		s[i] = s[i]();
		if(Array.isArray(s[i])) {
			for(var j in s[i][0])
				types[i].defineProperty(j, s[i][0][j]);
			s[i] = s[i][1];
		}
	}
	for(var i in s) {
		if('$constructor' in s[i]) {
			var ctor = s[i].$constructor;
			exports[i] = method(ctor[0], ctor[1], ctor[2], true, ctor[3]), exports[i].$type = types[i];
			delete s[i].$constructor;
		}
		for(var j in s[i])
			define(i, j, s[i][j]);
	}
}
var _ = types;
bindings({
	$RStr: function() {return {
		rwx_i: ['r_str_rwx_i', _.CString, [_.int]],
		hash: ['r_str_hash', _.int, [_.CString]],
		write: ['r_str_write', _.int, [_.int, _.CString]],
		rwx: ['r_str_rwx', _.int, [_.CString]],
		replace_char: ['r_str_replace_char', _.int, [_.CString, _.int, _.int]],
		ansi_len: ['r_str_ansi_len', _.int, [_.CString]],
		ansi_filter: ['r_str_ansi_filter', _.int, [_.CString, _.int]]
	};},
	$RFile: function() {return {
		rm: ['r_file_rm', _.bool, [_.CString]],
		tmpdir: ['r_file_tmpdir', _.CString, []],
		temp: ['r_file_temp', _.CString, [_.CString]],
		slurp: ['r_file_slurp', _.CString, [_.CString, _.int]],
		slurp_range: ['r_file_slurp_range', _.CString, [_.CString, _.uint64, _.int, _.int]],
		dump: ['r_file_dump', _.int, [_.CString, _.ptr(_.uint8), _.int]],
		basename: ['r_file_basename', _.CString, [_.CString]],
		abspath: ['r_file_abspath', _.CString, [_.CString]],
		exists: ['r_file_exists', _.bool, [_.CString]],
		slurp_line: ['r_file_slurp_line', _.bool, [_.CString, _.int, _.int]]
	};},
	$RLog: function() {return {
		msg: ['r_log_msg', _.void, [_.CString]],
		error: ['r_log_error', _.void, [_.CString]],
		file: ['r_log_file', _.void, [_.CString]],
		progress: ['r_log_progress', _.void, [_.CString, _.int]]
	};},
	$RHex: function() {return {
		str2bin: ['r_hex_str2bin', _.int, [_.CString, _.ptr(_.uint8)]],
		bin2str: ['r_hex_bin2str', _.int, [_.ptr(_.uint8), _.int, _.CString]],
		bin2strdup: ['r_hex_bin2strdup', _.CString, [_.ptr(_.uint8), _.int]]
	};},
	$RSystem: function() {return {
		sleep: ['r_sys_sleep', _.int, [_.int]],
		usleep: ['r_sys_usleep', _.int, [_.int]],
		getenv: ['r_sys_getenv', _.CString, [_.CString]],
		setenv: ['r_sys_setenv', _.bool, [_.CString, _.CString]],
		cmd: ['r_sys_cmd', _.int, [_.CString]],
		cmd_str: ['r_sys_cmd_str', _.CString, [_.CString, _.CString, _.int]],
		backtrace: ['r_sys_backtrace', _.void, []]
	};},
	RLibStruct: function() {return [{
		type: _.int,
		data: _.ptr(_.void)
	}, {}];},
	RBinFile: function() {return [{
		buf: _.ref(_.RBuffer),
		file: _.CString,
		size: _.int,
		offset: _.uint64,
		o: _.ref(_.RBinObject),
		curplugin: _.ref(_.RBinPlugin)
	}, {}];},
	RBinPlugin: function() {return [{}, {}];},
	RBinDwarfRow: function() {return [{
		address: _.uint64,
		file: _.CString,
		line: _.int,
		column: _.int
	}, {}];},
	RBinClass: function() {return [{
		name: _.CString,
		super: _.CString,
		index: _.int,
		methods: _.ref(_.RList(_.ref(_.RBinSymbol))),
		fields: _.ref(_.RList(_.ref(_.RBinField))),
		visibility: _.bool
	}, {}];},
	RBinObject: function() {return [{
		baddr: _.uint64,
		size: _.int,
		sections: _.ref(_.RList(_.ref(_.RBinSection))),
		imports: _.ref(_.RList(_.ref(_.RBinImport))),
		symbols: _.ref(_.RList(_.ref(_.RBinSymbol))),
		entries: _.ref(_.RList(_.ref(_.RBinAddr))),
		fields: _.ref(_.RList(_.ref(_.RBinField))),
		libs: _.ref(_.RList(_.ref(_.RBinSymbol))),
		relocs: _.ref(_.RList(_.ref(_.RBinReloc))),
		strings: _.ref(_.RList(_.ref(_.RBinString))),
		classes: _.ref(_.RList(_.ref(_.RBinClass))),
		lines: _.ref(_.RList(_.ref(_.RBinDwarfRow))),
		info: _.ref(_.RBinInfo),
		binsym: _.array(_.ref(_.RBinAddr), 4)
	}, {}];},
	RBinAddr: function() {return [{
		rva: _.uint64,
		offset: _.uint64
	}, {}];},
	RBinSection: function() {return [{
		name: _.array(_.char, 512),
		size: _.uint64,
		vsize: _.uint64,
		rva: _.uint64,
		offset: _.uint64,
		srwx: _.uint64
	}, {}];},
	RBinSymbol: function() {return [{
		name: _.array(_.char, 512),
		forwarder: _.array(_.char, 512),
		bind: _.array(_.char, 512),
		type: _.array(_.char, 512),
		classname: _.CString,
		rva: _.uint64,
		offset: _.uint64,
		size: _.uint64,
		ordinal: _.uint64
	}, {}];},
	RBinImport: function() {return [{
		name: _.array(_.char, 512),
		bind: _.array(_.char, 512),
		type: _.array(_.char, 512),
		ordinal: _.uint64
	}, {}];},
	RBinReloc: function() {return [{
		type: _.uint8,
		additive: _.uint8,
		import: _.ref(_.RBinImport),
		addend: _.int64,
		rva: _.uint64,
		offset: _.uint64
	}, {}];},
	RBinInfo: function() {return [{
		file: _.array(_.char, 512),
		type: _.array(_.char, 512),
		bclass: _.array(_.char, 512),
		rclass: _.array(_.char, 512),
		arch: _.array(_.char, 512),
		machine: _.array(_.char, 512),
		os: _.array(_.char, 512),
		subsystem: _.array(_.char, 512),
		rpath: _.array(_.char, 512),
		lang: _.CString,
		bits: _.int,
		has_va: _.bool,
		has_pi: _.bool,
		big_endian: _.bool,
		dbg_info: _.uint64
	}, {}];},
	RBinString: function() {return [{
		string: _.array(_.char, 512),
		rva: _.uint64,
		offset: _.uint64,
		ordinal: _.uint64,
		size: _.uint64
	}, {}];},
	RBinField: function() {return [{
		name: _.array(_.char, 512),
		rva: _.uint64,
		offset: _.uint64
	}, {}];},
	RBin: function() {return [{
		file: _.CString,
		cur: _.ref(_.RBinFile),
		narch: _.int
	}, {
		$Sym: {}/*types.Enum*/,
		$RelocType: {}/*types.Enum*/,
		delete: ['r_bin_free', _.void, [_.ref(_.RBin)]],
		$constructor: ['r_bin_new', _.ref(_.RBin), []],
		wr_scn_resize: ['r_bin_wr_scn_resize', _.uint64, [_.ref(_.RBin), _.CString, _.uint64]],
		wr_rpath_del: ['r_bin_wr_rpath_del', _.int, [_.ref(_.RBin)]],
		wr_output: ['r_bin_wr_output', _.int, [_.ref(_.RBin), _.CString]],
		load: ['r_bin_load', _.int, [_.ref(_.RBin), _.CString, _.uint64, _.uint64, _.bool]],
		create: ['r_bin_create', _.ref(_.RBuffer), [_.ref(_.RBin), _.ptr(_.uint8), _.int, _.ptr(_.uint8), _.int]],
		use_arch: ['r_bin_use_arch', _.int, [_.ref(_.RBin), _.CString, _.int, _.CString]],
		select: ['r_bin_select', _.int, [_.ref(_.RBin), _.CString, _.int, _.CString]],
		select_idx: ['r_bin_select_idx', _.int, [_.ref(_.RBin), _.int]],
		list: ['r_bin_list', _.int, [_.ref(_.RBin)]],
		get_baddr: ['r_bin_get_baddr', _.uint64, [_.ref(_.RBin)]],
		get_sym: ['r_bin_get_sym', _.ref(_.RBinAddr), [_.ref(_.RBin), _.int]],
		get_entries: ['r_bin_get_entries', _.ref(_.RList(_.ref(_.RBinAddr))), [_.ref(_.RBin)]],
		get_fields: ['r_bin_get_fields', _.ref(_.RList(_.ref(_.RBinField))), [_.ref(_.RBin)]],
		get_imports: ['r_bin_get_imports', _.ref(_.RList(_.ref(_.RBinImport))), [_.ref(_.RBin)]],
		get_sections: ['r_bin_get_sections', _.ref(_.RList(_.ref(_.RBinSection))), [_.ref(_.RBin)]],
		get_strings: ['r_bin_get_strings', _.ref(_.RList(_.ref(_.RBinString))), [_.ref(_.RBin)]],
		get_symbols: ['r_bin_get_symbols', _.ref(_.RList(_.ref(_.RBinSymbol))), [_.ref(_.RBin)]],
		get_relocs: ['r_bin_get_relocs', _.ref(_.RList(_.ref(_.RBinReloc))), [_.ref(_.RBin)]],
		get_libs: ['r_bin_get_libs', _.ref(_.RList(_.CString)), [_.ref(_.RBin)]],
		get_info: ['r_bin_get_info', _.ref(_.RBinInfo), [_.ref(_.RBin)]],
		is_big_endian: ['r_bin_is_big_endian', _.int, [_.ref(_.RBin)]],
		is_stripped: ['r_bin_is_stripped', _.int, [_.ref(_.RBin)]],
		is_static: ['r_bin_is_static', _.int, [_.ref(_.RBin)]],
		has_dbg_linenums: ['r_bin_has_dbg_linenums', _.int, [_.ref(_.RBin)]],
		has_dbg_syms: ['r_bin_has_dbg_syms', _.int, [_.ref(_.RBin)]],
		has_dbg_relocs: ['r_bin_has_dbg_relocs', _.int, [_.ref(_.RBin)]],
		meta_get_line: ['r_bin_meta_get_line', _.int, [_.ref(_.RBin), _.uint64, _.CString, _.int, _.int]],
		meta_get_source_line: ['r_bin_meta_get_source_line', _.CString, [_.ref(_.RBin), _.uint64]],
		get_object: ['r_bin_get_object', _.ref(_.RBinObject), [_.ref(_.RBin)]]
	}];},
	RStrBuf: function() {return [{}, {
		delete: ['r_strbuf_free', _.void, [_.ref(_.RStrBuf)]],
		$constructor: ['r_strbuf_new', _.ref(_.RStrBuf), [_.CString]],
		set: ['r_strbuf_set', _.bool, [_.ref(_.RStrBuf), _.CString]],
		setf: ['r_strbuf_setf', _.bool, [_.ref(_.RStrBuf), _.CString], 'variadic'],
		append: ['r_strbuf_append', _.bool, [_.ref(_.RStrBuf), _.CString]],
		get: ['r_strbuf_get', _.CString, [_.ref(_.RStrBuf)]]
	}];},
	RNum: function() {return [{}, {
		$constructor: ['r_num_new', _.ref(_.RNum), [_.delegate(_.uint64, [_.CString, _.ptr(_.int)]), _.ptr(_.void)]],
		get: ['r_num_get', _.uint64, [_.ref(_.RNum), _.CString]],
		math: ['r_num_math', _.uint64, [_.ref(_.RNum), _.CString]]
	}];},
	RBuffer: function() {return [{
		buf: _.ptr(_.uint8),
		length: _.int,
		cur: _.int,
		base: _.uint64
	}, {
		delete: ['r_buf_free', _.void, [_.ref(_.RBuffer)]],
		$constructor: ['r_buf_new', _.ref(_.RBuffer), []],
		read_at: ['r_buf_read_at', _.int, [_.ref(_.RBuffer), _.uint64, _.ptr(_.uint8), _.int]],
		write_at: ['r_buf_write_at', _.int, [_.ref(_.RBuffer), _.uint64, _.ptr(_.uint8), _.int]],
		set_bytes: ['r_buf_set_bytes', _.bool, [_.ref(_.RBuffer), _.ptr(_.uint8), _.int]]
	}];},
	RList: function(G) {return [{
		head: _.ptr(_.RListIter(G)),
		tail: _.ptr(_.RListIter(G))
	}, {
		delete: ['r_list_free', _.void, [_.ref(_.RList(G))]],
		append: ['r_list_append', _.void, [_.ref(_.RList(G)), G]],
		prepend: ['r_list_prepend', _.void, [_.ref(_.RList(G)), G]],
		iterator: ['r_list_iterator', _.ref(_.RListIter(G)), [_.ref(_.RList(G))]],
		forEach: defaults.forEach,
		$constructor: ['r_list_new', _.ref(_.RList(G)), []],
		length: ['r_list_length', _.int, [_.ref(_.RList(G))]],
		del_n: ['r_list_del_n', _.bool, [_.ref(_.RList(G)), _.int]],
		get_top: ['r_list_get_top', _.bool, [_.ref(_.RList(G))]],
		pop: ['r_list_pop', G, [_.ref(_.RList(G))]]
	}];},
	RListIter: function(G) {return [{
		data: G,
		n: _.ref(_.RListIter(G)),
		p: _.ref(_.RListIter(G))
	}, {
		delete: ['r_list_iter_free', _.void, [_.ref(_.RListIter(G))]],
		get_data: ['r_list_iter_get_data', G, [_.ref(_.RListIter(G))]],
		get_next: ['r_list_iter_get_next', _.ref(_.RListIter(G)), [_.ref(_.RListIter(G))]]
	}];},
	RRangeItem: function() {return [{
		fr: _.uint64,
		to: _.uint64,
		data: _.ptr(_.uint8),
		datalen: _.int
	}, {}];},
	RRange: function() {return [{}, {
		delete: ['r_range_free', _.void, [_.ref(_.RRange)]],
		$constructor: ['r_range_new', _.ref(_.RRange), []],
		$constructor: ['r_range_new_from_string', _.ref(_.RRange), [_.CString]],
		item_get: ['r_range_item_get', _.ptr(_.RRangeItem), [_.ref(_.RRange), _.uint64]],
		size: ['r_range_size', _.uint64, [_.ref(_.RRange)]],
		add_from_string: ['r_range_add_from_string', _.uint64, [_.ref(_.RRange), _.CString]],
		contains: ['r_range_contains', _.bool, [_.ref(_.RRange), _.uint64]],
		sort: ['r_range_sort', _.bool, [_.ref(_.RRange)]],
		list: ['r_range_list', _.bool, [_.ref(_.RRange), _.bool]],
		get_n: ['r_range_get_n', _.bool, [_.ref(_.RRange), _.int, _.uint64, _.uint64]],
		inverse: ['r_range_inverse', _.ptr(_.RRange), [_.ref(_.RRange), _.uint64, _.uint64, _.int]]
	}];},
	RLib: function() {return [{}, {
		delete: ['r_lib_free', _.void, [_.ref(_.RLib)]],
		$constructor: ['r_lib_new', _.ref(_.RLib), [_.CString]],
		close: ['r_lib_close', _.bool, [_.ref(_.RLib), _.CString]],
		opendir: ['r_lib_opendir', _.int, [_.ref(_.RLib), _.CString]],
		$path: ['r_lib_path', _.CString, [_.CString]],
		$dl_open: ['r_lib_dl_open', _.ptr(_.void), [_.CString]],
		dl_sym: ['r_lib_dl_sym', _.ptr(_.void), [_.ref(_.RLib), _.CString]],
		$dl_close: ['r_lib_dl_close', _.bool, [_.ptr(_.void)]],
		$dl_check_filename: ['r_lib_dl_check_filename', _.bool, [_.CString]],
		del_handler: ['r_lib_del_handler', _.bool, [_.ref(_.RLib), _.int]]
	}];}
});
exports.RLibType = {}/*types.Enum*/;
exports.RLibType.IO = 0;
exports.RLibType.DBG = 1;
exports.RLibType.LANG = 2;
exports.RLibType.ASM = 3;
exports.RLibType.ANAL = 4;
exports.RLibType.PARSE = 5;
exports.RLibType.BIN = 6;
exports.RLibType.BP = 8;
exports.RLibType.SYSCALL = 9;
exports.RLibType.FASTCALL = 10;
exports.RLibType.CRYPTO = 11;
exports.RLibType.CMD = 12;
exports.RLibType.LAST = 14;
exports.RBin.Sym.ENTRY = 0;
exports.RBin.Sym.INIT = 1;
exports.RBin.Sym.MAIN = 2;
exports.RBin.Sym.FINI = 3;
exports.RBin.Sym.LAST = 4;
exports.RBin.RelocType._8 = 0;
exports.RBin.RelocType._16 = 1;
exports.RBin.RelocType._32 = 2;
exports.RBin.RelocType._64 = 3;
