
/* DO NOT EDIT. Automatically generated by valabind from r_core */

var ffi = require('ffi'), ref = require('ref'), Struct = require('ref-struct');
var lib = new ffi.DynamicLibrary('libr_core'+ffi.LIB_EXT);

function Tname(T) {
	return T.hasOwnProperty('$name') ? T.$name : T.name;
}

var types = exports.type = {};

for(var i in ref.types)
	if(i != 'Utf8String') // Try not to trip the deprecated warning.
		types[i] = ref.types[i];

types.staticCString = function staticCString(N) {
	var r = Object.create(types.char);
	r.name = 'char['+N+']';
	r.size *= N;
	r.get = function get(buf, offset) {
		if(buf.isNull())
			return null;
		// TODO enforce maxLength of N
		return buf.readCString(offset);
	};
	r.set = function set(buf, offset, val) {
		// TODO enforce maxLength of N
		return buf.writeCString(val, offset);
	};
	return r;
};

var ptrCache = [], ptrCacheTo = [];
types.ptr = function PointerType(T) {
	T = ref.coerceType(T);
	if(T == types.char)
		return types.CString;
	var i = ptrCache.indexOf(T);
	return i === -1 ? ptrCacheTo[ptrCache.push(T)-1] = ref.refType(T) : ptrCacheTo[i];
};

var refCache = [], refCacheTo = [];
types.ref = function ReferenceType(T) {
	T = ref.coerceType(T);
	var i = refCache.indexOf(T);
	if(i !== -1)
		return refCacheTo[i];
	var p = types.ptr(T), r = refCacheTo[refCache.push(T)-1] = Object.create(p);
	r.indirection = 1;
	r.size = ref.sizeof.pointer;
	r.alignment = ref.alignof.pointer;
	r.name = Tname(T)+'&';
	r.ffi_type = ffi.FFI_TYPES.pointer;
	r.get = function get(buf, offset) {
		buf = ref.get(buf, offset, p);
		if(buf.isNull())
			return null;
		return buf.deref();
	};
	r.set = function set(buf, offset, val) {
		if(!val)
			return ref.set(buf, offset, null, p);
		if(!val.buffer)
			throw new TypeError('valabind ['+r.name+']#set got a bad value');
		return ref.set(buf, offset, val.buffer, p);
	};
	return r;
};

types.array = function ArrayType(T, N) {
	T = ref.coerceType(T);
	if(T == types.char)
		return types.staticCString(N);
	var r = Object.create(T);
	r.size *= N;
	r.name = Tname(T)+'['+N+']';
	function ArrayType(buffer, base) {
		this.buffer = buffer;
		this._base = base;
	}
	ArrayType.prototype = [];
	ArrayType.prototype.constructor = ArrayType;
	for(var i = 0; i < N; i++)
		Object.defineProperty(ArrayType.prototype, i, {
			get: function get() {
				return ref.get(this.buffer, this._base+T.size*i, T);
			},
			set: function set(val) {
				return ref.set(this.buffer, this._base+T.size*i, val, T);
			},
			enumerable: true
		});
	r.get = function get(buf, offset) {
		return new ArrayType(buf, offset);
	};
	r.set = function set(buf, offset, val) {
		for(var i in val) {
			if(isNaN(i = +i) || i >= N)
				continue;
			ref.set(buf, offset+T.size*i, val[i], T);
		}
	};
	return r;
};

types.delegate = function DelegateType(ret, args) {
	var p = types.ptr(types.void), r = Object.create(p);
	r.indirection = 1;
	r.name = Tname(ret)+'('+args.map(function(T) {return Tname(T);}).join(', ')+')';
	r.get = function get(buf, offset) {
		buf = ref.get(buf, offset, p);
		if(buf.isNull())
			return null;
		return ffi.ForeignFunction(buf, ret, args);
	};
	r.set = function set(buf, offset, val) {
		return ref.set(buf, offset, ffi.Callback(ret, args, void(0), val));
	};
	return r;
};

var defaults = {
	forEach: function forEach(callback, thisArg) {
		if({}.toString.call(callback) != '[object Function]')
			throw new TypeError(callback + ' is not a function');

		for(var T = thisArg || T, iter = this.iterator(); iter; iter = iter.get_next())
			callback.call(T, iter.get_data(), iter, this);
	}
};

function bindings(s) {
	function method(name, ret, args, static, more) {
		var f = (more == 'variadic' ? ffi.VariadicForeignFunction :
			ffi.ForeignFunction)(lib.get(name), ret, args);
		if(static)
			return f;
		return function() {
			[].unshift.call(arguments, this);
			return f.apply(null, arguments);
		};
	}

	function define(base, n, m) {
		var static = n[0] == '$' && ((n = n.slice(1)), true);
		static = static || base[0] == '$' && ((base = base.slice(1)), true);
		if(Array.isArray(m))
			m = method(m[0], m[1], m[2], static, m[3]);
		static ? exports[base][n] = m : types[base].prototype[n] = m;
	}

	function makeGeneric(G, n) {
		var cache = [], cacheTo = [];
		types[n] = function() {
			var l = arguments.length, args = [], c;

			// Coerce all type arguments.
			for(var i = 0; i < l; i++)
				args[i] = ref.coerceType(arguments[i].$type || arguments[i]);

			// Look in the cache, if the generic was already built.
			for(var i = 0; i < cache.length; i++) {
				if((c = cache[i]).length !== l)
					continue;
				for(var j = 0; j < l && c[j] === args[j]; j++);
				if(j === l)
					return cacheTo[i];
			}

			// Create the new generic.
			var generic = cacheTo[cache.push(args)-1] = Struct(), g = G.apply(null, args);
			generic.$name = n+'<'+args.map(function(T) {return Tname(T);}).join(', ')+'>';

			// Define all the generic's propoerties.
			for(var i in g[0])
				generic.defineProperty(i, g[0][i]);

			// Insert all the generic's methods.
			if(g[1])
				for(var i in g[1]) {
					var m = g[1][i];
					if(Array.isArray(m))
						m = method(m[0], m[1], m[2], false, m[3]);
					generic.prototype[i] = m;
				}
			return generic;
		};
	}
	for(var i in s) {
		if(s[i].length)
			makeGeneric(s[i], i);
		else if(i[0] == '$')
			exports[i.slice(1)] = {};
		else
			exports[i] = types[i] = Struct(), types[i].$name = i;
	}
	for(var i in s) {
		if(s[i].length) {
			// TODO insert constructor
			delete s[i];
			continue;
		}
		s[i] = s[i]();
		if(Array.isArray(s[i])) {
			for(var j in s[i][0])
				types[i].defineProperty(j, s[i][0][j]);
			s[i] = s[i][1];
		}
	}
	for(var i in s) {
		if('$constructor' in s[i]) {
			var ctor = s[i].$constructor;
			exports[i] = method(ctor[0], ctor[1], ctor[2], true, ctor[3]), exports[i].$type = types[i];
			delete s[i].$constructor;
		}
		for(var j in s[i])
			define(i, j, s[i][j]);
	}
}
var _ = types;
bindings({
	$RStr: function() {return {
		rwx_i: ['r_str_rwx_i', _.CString, [_.int]],
		hash: ['r_str_hash', _.int, [_.CString]],
		write: ['r_str_write', _.int, [_.int, _.CString]],
		rwx: ['r_str_rwx', _.int, [_.CString]],
		replace_char: ['r_str_replace_char', _.int, [_.CString, _.int, _.int]],
		ansi_len: ['r_str_ansi_len', _.int, [_.CString]],
		ansi_filter: ['r_str_ansi_filter', _.int, [_.CString, _.int]]
	};},
	$RFile: function() {return {
		rm: ['r_file_rm', _.bool, [_.CString]],
		tmpdir: ['r_file_tmpdir', _.CString, []],
		temp: ['r_file_temp', _.CString, [_.CString]],
		slurp: ['r_file_slurp', _.CString, [_.CString, _.int]],
		slurp_range: ['r_file_slurp_range', _.CString, [_.CString, _.uint64, _.int, _.int]],
		dump: ['r_file_dump', _.int, [_.CString, _.ptr(_.uint8), _.int]],
		basename: ['r_file_basename', _.CString, [_.CString]],
		abspath: ['r_file_abspath', _.CString, [_.CString]],
		exists: ['r_file_exists', _.bool, [_.CString]],
		slurp_line: ['r_file_slurp_line', _.bool, [_.CString, _.int, _.int]]
	};},
	$RLog: function() {return {
		msg: ['r_log_msg', _.void, [_.CString]],
		error: ['r_log_error', _.void, [_.CString]],
		file: ['r_log_file', _.void, [_.CString]],
		progress: ['r_log_progress', _.void, [_.CString, _.int]]
	};},
	$RHex: function() {return {
		str2bin: ['r_hex_str2bin', _.int, [_.CString, _.ptr(_.uint8)]],
		bin2str: ['r_hex_bin2str', _.int, [_.ptr(_.uint8), _.int, _.CString]],
		bin2strdup: ['r_hex_bin2strdup', _.CString, [_.ptr(_.uint8), _.int]]
	};},
	$RSystem: function() {return {
		sleep: ['r_sys_sleep', _.int, [_.int]],
		usleep: ['r_sys_usleep', _.int, [_.int]],
		getenv: ['r_sys_getenv', _.CString, [_.CString]],
		setenv: ['r_sys_setenv', _.bool, [_.CString, _.CString]],
		cmd: ['r_sys_cmd', _.int, [_.CString]],
		cmd_str: ['r_sys_cmd_str', _.CString, [_.CString, _.CString, _.int]],
		backtrace: ['r_sys_backtrace', _.void, []]
	};},
	RLibStruct: function() {return [{
		type: _.int,
		data: _.ptr(_.void)
	}, {}];},
	RCoreFile: function() {return [{
		uri: _.CString,
		filename: _.CString,
		seek: _.uint64,
		size: _.uint64,
		map: _.ref(_.RIOMap),
		rwx: _.int,
		dbg: _.bool,
		fd: _.ref(_.RIODesc)
	}, {}];},
	RCoreAsmHit: function() {return [{
		code: _.CString,
		len: _.int,
		addr: _.uint64
	}, {
		$constructor: ['r_core_asm_hit_new', _.ref(_.RCoreAsmHit), []]
	}];},
	RCore: function() {return [{
		bin: _.ref(_.RBin),
		config: _.ref(_.RConfig),
		offset: _.uint64,
		blocksize: _.uint32,
		blocksize_max: _.uint32,
		block: _.ptr(_.uint8),
		oobi: _.ptr(_.uint8),
		ffio: _.int,
		oobi_len: _.int,
		yank_buf: _.ptr(_.uint8),
		yank_len: _.int,
		yank_off: _.uint64,
		tmpseek: _.int,
		vmode: _.bool,
		interrupted: _.int,
		cons: _.ref(_.RCons),
		kv: _.ref(_.RPair),
		io: _.ref(_.RIO),
		file: _.ref(_.RCoreFile),
		files: _.ref(_.RList(_.ref(_.RCoreFile))),
		num: _.ref(_.RNum),
		lib: _.ref(_.RLib),
		rcmd: _.ref(_.RCmd),
		anal: _.ref(_.RAnal),
		assembler: _.ref(_.RAsm),
		reflines: _.ref(_.RAnalRefline),
		reflines2: _.ref(_.RAnalRefline),
		parser: _.ref(_.RParse),
		print: _.ref(_.RPrint),
		lang: _.ref(_.RLang),
		dbg: _.ref(_.RDebug),
		flags: _.ref(_.RFlag),
		search: _.ref(_.RSearch),
		sign: _.ref(_.RSign),
		fs: _.ref(_.RFS),
		egg: _.ref(_.REgg),
		cmdqueue: _.CString,
		lastcmd: _.CString,
		cmdrepeat: _.int,
		inc: _.uint64
	}, {
		delete: ['r_core_free', _.void, [_.ref(_.RCore)]],
		get_cons: ['r_core_get_cons', _.ptr(_.RCons), [_.ref(_.RCore)]],
		get_config: ['r_core_get_config', _.ptr(_.RConfig), [_.ref(_.RCore)]],
		$constructor: ['r_core_new', _.ref(_.RCore), []],
		$ncast: ['r_core_ncast', _.ref(_.RCore), [_.uint64]],
		loadlibs: ['r_core_loadlibs', _.bool, [_.ref(_.RCore)]],
		prompt: ['r_core_prompt', _.int, [_.ref(_.RCore), _.bool]],
		prompt_loop: ['r_core_prompt_loop', _.void, [_.ref(_.RCore)]],
		prompt_exec: ['r_core_prompt_exec', _.int, [_.ref(_.RCore)]],
		cmd: ['r_core_cmd', _.int, [_.ref(_.RCore), _.CString, _.bool]],
		cmd0: ['r_core_cmd0', _.int, [_.ref(_.RCore), _.CString]],
		cmd_flush: ['r_core_cmd_flush', _.void, [_.ref(_.RCore)]],
		cmd_init: ['r_core_cmd_init', _.void, [_.ref(_.RCore)]],
		cmd_file: ['r_core_cmd_file', _.bool, [_.ref(_.RCore), _.CString]],
		cmd_command: ['r_core_cmd_command', _.int, [_.ref(_.RCore), _.CString]],
		cmd_str: ['r_core_cmd_str', _.CString, [_.ref(_.RCore), _.CString]],
		cmd_str_pipe: ['r_core_cmd_str_pipe', _.CString, [_.ref(_.RCore), _.CString]],
		op_str: ['r_core_op_str', _.CString, [_.ref(_.RCore), _.uint64]],
		op_anal: ['r_core_op_anal', _.ref(_.RAnalOp), [_.ref(_.RCore), _.uint64]],
		disassemble: ['r_core_disassemble', _.ptr(_.RAsmOp), [_.ref(_.RCore), _.uint64]],
		disassemble_instr: ['r_core_disassemble_instr', _.CString, [_.ref(_.RCore), _.uint64, _.int]],
		disassemble_bytes: ['r_core_disassemble_bytes', _.CString, [_.ref(_.RCore), _.uint64, _.int]],
		search_preludes: ['r_core_search_preludes', _.int, [_.ref(_.RCore)]],
		search_prelude: ['r_core_search_prelude', _.int, [_.ref(_.RCore), _.uint64, _.uint64, _.ptr(_.uint8), _.int, _.ptr(_.uint8), _.int]],
		anal_all: ['r_core_anal_all', _.bool, [_.ref(_.RCore)]],
		anal_search: ['r_core_anal_search', _.int, [_.ref(_.RCore), _.uint64, _.uint64, _.uint64]],
		anal_refs: ['r_core_anal_refs', _.void, [_.ref(_.RCore), _.uint64, _.int]],
		anal_bb: ['r_core_anal_bb', _.int, [_.ref(_.RCore), _.ref(_.RAnalFunction), _.uint64, _.int]],
		anal_bb_seek: ['r_core_anal_bb_seek', _.int, [_.ref(_.RCore), _.uint64]],
		anal_fcn: ['r_core_anal_fcn', _.int, [_.ref(_.RCore), _.uint64, _.uint64, _.int, _.int]],
		anal_fcn_list: ['r_core_anal_fcn_list', _.int, [_.ref(_.RCore), _.CString, _.bool]],
		anal_graph: ['r_core_anal_graph', _.int, [_.ref(_.RCore), _.uint64, _.int]],
		anal_ref_list: ['r_core_anal_ref_list', _.int, [_.ref(_.RCore), _.bool]],
		project_open: ['r_core_project_open', _.int, [_.ref(_.RCore), _.CString]],
		project_save: ['r_core_project_save', _.int, [_.ref(_.RCore), _.CString]],
		project_info: ['r_core_project_info', _.CString, [_.ref(_.RCore), _.CString]],
		gdiff: ['r_core_gdiff', _.int, [_.ref(_.RCore), _.ptr(_.RCore)]],
		rtr_help: ['r_core_rtr_help', _.void, [_.ref(_.RCore)]],
		rtr_pushout: ['r_core_rtr_pushout', _.void, [_.ref(_.RCore), _.CString]],
		rtr_list: ['r_core_rtr_list', _.void, [_.ref(_.RCore)]],
		rtr_add: ['r_core_rtr_add', _.void, [_.ref(_.RCore), _.CString]],
		rtr_remove: ['r_core_rtr_remove', _.void, [_.ref(_.RCore), _.CString]],
		rtr_session: ['r_core_rtr_session', _.void, [_.ref(_.RCore), _.CString]],
		rtr_cmd: ['r_core_rtr_cmd', _.void, [_.ref(_.RCore), _.CString]],
		read_at: ['r_core_read_at', _.bool, [_.ref(_.RCore), _.uint64, _.ptr(_.uint8), _.int]],
		write_at: ['r_core_write_at', _.bool, [_.ref(_.RCore), _.uint64, _.ptr(_.uint8), _.int]],
		block_read: ['r_core_block_read', _.int, [_.ref(_.RCore), _.bool]],
		block_size: ['r_core_block_size', _.int, [_.ref(_.RCore), _.int]],
		seek: ['r_core_seek', _.int, [_.ref(_.RCore), _.uint64, _.bool]],
		seek_align: ['r_core_seek_align', _.int, [_.ref(_.RCore), _.uint64, _.int]],
		yank: ['r_core_yank', _.bool, [_.ref(_.RCore), _.uint64, _.int]],
		yank_paste: ['r_core_yank_paste', _.bool, [_.ref(_.RCore), _.uint64, _.int]],
		visual: ['r_core_visual', _.int, [_.ref(_.RCore), _.CString]],
		visual_cmd: ['r_core_visual_cmd', _.int, [_.ref(_.RCore), _.int]],
		serve: ['r_core_serve', _.int, [_.ref(_.RCore), _.ref(_.RIODesc)]],
		asm_strsearch: ['r_core_asm_strsearch', _.ref(_.RList(_.ref(_.RCoreAsmHit))), [_.ref(_.RCore), _.CString, _.uint64, _.uint64]],
		asm_bwdisassemble: ['r_core_asm_bwdisassemble', _.ref(_.RList(_.ref(_.RCoreAsmHit))), [_.ref(_.RCore), _.uint64, _.int, _.int]],
		search_cb: ['r_core_search_cb', _.bool, [_.ref(_.RCore), _.uint64, _.uint64, _.delegate(_.int, [_.uint64, _.ptr(_.uint8), _.int])]],
		file_open: ['r_core_file_open', _.ref(_.RCoreFile), [_.ref(_.RCore), _.CString, _.int, _.uint64]],
		file_close: ['r_core_file_close', _.bool, [_.ref(_.RCore), _.ref(_.RCoreFile)]],
		file_close_fd: ['r_core_file_close_fd', _.bool, [_.ref(_.RCore), _.int]],
		file_list: ['r_core_file_list', _.bool, [_.ref(_.RCore)]],
		seek_delta: ['r_core_seek_delta', _.int, [_.ref(_.RCore), _.int64]],
		bin_load: ['r_core_bin_load', _.bool, [_.ref(_.RCore), _.CString, _.uint64]]
	}];},
	RCmd: function() {return [{}, {
		delete: ['r_cmd_free', _.void, [_.ref(_.RCmd)]],
		$constructor: ['r_cmd_new', _.ref(_.RCmd), []],
		set_data: ['r_cmd_set_data', _.void, [_.ref(_.RCmd), _.ptr(_.void)]],
		add: ['r_cmd_add', _.bool, [_.ref(_.RCmd), _.CString, _.CString, _.delegate(_.bool, [_.ptr(_.void), _.CString])]],
		add_long: ['r_cmd_add_long', _.bool, [_.ref(_.RCmd), _.CString, _.CString, _.CString]],
		del: ['r_cmd_del', _.bool, [_.ref(_.RCmd), _.CString]],
		call: ['r_cmd_call', _.bool, [_.ref(_.RCmd), _.CString]],
		call_long: ['r_cmd_call_long', _.bool, [_.ref(_.RCmd), _.CString]]
	}];},
	RStrBuf: function() {return [{}, {
		delete: ['r_strbuf_free', _.void, [_.ref(_.RStrBuf)]],
		$constructor: ['r_strbuf_new', _.ref(_.RStrBuf), [_.CString]],
		set: ['r_strbuf_set', _.bool, [_.ref(_.RStrBuf), _.CString]],
		setf: ['r_strbuf_setf', _.bool, [_.ref(_.RStrBuf), _.CString], 'variadic'],
		append: ['r_strbuf_append', _.bool, [_.ref(_.RStrBuf), _.CString]],
		get: ['r_strbuf_get', _.CString, [_.ref(_.RStrBuf)]]
	}];},
	RNum: function() {return [{}, {
		$constructor: ['r_num_new', _.ref(_.RNum), [_.delegate(_.uint64, [_.CString, _.ptr(_.int)]), _.ptr(_.void)]],
		get: ['r_num_get', _.uint64, [_.ref(_.RNum), _.CString]],
		math: ['r_num_math', _.uint64, [_.ref(_.RNum), _.CString]]
	}];},
	RBuffer: function() {return [{
		buf: _.ptr(_.uint8),
		length: _.int,
		cur: _.int,
		base: _.uint64
	}, {
		delete: ['r_buf_free', _.void, [_.ref(_.RBuffer)]],
		$constructor: ['r_buf_new', _.ref(_.RBuffer), []],
		read_at: ['r_buf_read_at', _.int, [_.ref(_.RBuffer), _.uint64, _.ptr(_.uint8), _.int]],
		write_at: ['r_buf_write_at', _.int, [_.ref(_.RBuffer), _.uint64, _.ptr(_.uint8), _.int]],
		set_bytes: ['r_buf_set_bytes', _.bool, [_.ref(_.RBuffer), _.ptr(_.uint8), _.int]]
	}];},
	RList: function(G) {return [{
		head: _.ptr(_.RListIter(G)),
		tail: _.ptr(_.RListIter(G))
	}, {
		delete: ['r_list_free', _.void, [_.ref(_.RList(G))]],
		append: ['r_list_append', _.void, [_.ref(_.RList(G)), G]],
		prepend: ['r_list_prepend', _.void, [_.ref(_.RList(G)), G]],
		iterator: ['r_list_iterator', _.ref(_.RListIter(G)), [_.ref(_.RList(G))]],
		forEach: defaults.forEach,
		$constructor: ['r_list_new', _.ref(_.RList(G)), []],
		length: ['r_list_length', _.int, [_.ref(_.RList(G))]],
		del_n: ['r_list_del_n', _.bool, [_.ref(_.RList(G)), _.int]],
		get_top: ['r_list_get_top', _.bool, [_.ref(_.RList(G))]],
		pop: ['r_list_pop', G, [_.ref(_.RList(G))]]
	}];},
	RListIter: function(G) {return [{
		data: G,
		n: _.ref(_.RListIter(G)),
		p: _.ref(_.RListIter(G))
	}, {
		delete: ['r_list_iter_free', _.void, [_.ref(_.RListIter(G))]],
		get_data: ['r_list_iter_get_data', G, [_.ref(_.RListIter(G))]],
		get_next: ['r_list_iter_get_next', _.ref(_.RListIter(G)), [_.ref(_.RListIter(G))]]
	}];},
	RRangeItem: function() {return [{
		fr: _.uint64,
		to: _.uint64,
		data: _.ptr(_.uint8),
		datalen: _.int
	}, {}];},
	RRange: function() {return [{}, {
		delete: ['r_range_free', _.void, [_.ref(_.RRange)]],
		$constructor: ['r_range_new', _.ref(_.RRange), []],
		$constructor: ['r_range_new_from_string', _.ref(_.RRange), [_.CString]],
		item_get: ['r_range_item_get', _.ptr(_.RRangeItem), [_.ref(_.RRange), _.uint64]],
		size: ['r_range_size', _.uint64, [_.ref(_.RRange)]],
		add_from_string: ['r_range_add_from_string', _.uint64, [_.ref(_.RRange), _.CString]],
		contains: ['r_range_contains', _.bool, [_.ref(_.RRange), _.uint64]],
		sort: ['r_range_sort', _.bool, [_.ref(_.RRange)]],
		list: ['r_range_list', _.bool, [_.ref(_.RRange), _.bool]],
		get_n: ['r_range_get_n', _.bool, [_.ref(_.RRange), _.int, _.uint64, _.uint64]],
		inverse: ['r_range_inverse', _.ptr(_.RRange), [_.ref(_.RRange), _.uint64, _.uint64, _.int]]
	}];},
	RLib: function() {return [{}, {
		delete: ['r_lib_free', _.void, [_.ref(_.RLib)]],
		$constructor: ['r_lib_new', _.ref(_.RLib), [_.CString]],
		close: ['r_lib_close', _.bool, [_.ref(_.RLib), _.CString]],
		opendir: ['r_lib_opendir', _.int, [_.ref(_.RLib), _.CString]],
		$path: ['r_lib_path', _.CString, [_.CString]],
		$dl_open: ['r_lib_dl_open', _.ptr(_.void), [_.CString]],
		dl_sym: ['r_lib_dl_sym', _.ptr(_.void), [_.ref(_.RLib), _.CString]],
		$dl_close: ['r_lib_dl_close', _.bool, [_.ptr(_.void)]],
		$dl_check_filename: ['r_lib_dl_check_filename', _.bool, [_.CString]],
		del_handler: ['r_lib_del_handler', _.bool, [_.ref(_.RLib), _.int]]
	}];},
	RCons: function() {return [{
		is_interactive: _.bool,
		is_html: _.bool,
		rows: _.int,
		columns: _.int
	}, {
		$singleton: ['r_cons_singleton', _.ref(_.RCons), []],
		$eof: ['r_cons_eof', _.bool, []],
		$pipe_open: ['r_cons_pipe_open', _.int, [_.CString, _.int, _.bool]],
		$pipe_close: ['r_cons_pipe_close', _.void, [_.int]],
		$clear: ['r_cons_clear', _.void, []],
		$clear00: ['r_cons_clear00', _.void, []],
		$reset: ['r_cons_reset', _.void, []],
		$gotoxy: ['r_cons_gotoxy', _.void, [_.int, _.int]],
		$set_raw: ['r_cons_set_raw', _.void, [_.bool]],
		$printf: ['r_cons_printf', _.void, [_.CString], 'variadic'],
		$strcat: ['r_cons_strcat', _.void, [_.CString]],
		$memcat: ['r_cons_memcat', _.void, [_.CString, _.int]],
		$newline: ['r_cons_newline', _.void, []],
		$flush: ['r_cons_flush', _.void, []],
		$filter: ['r_cons_filter', _.void, []],
		$visual_flush: ['r_cons_visual_flush', _.void, []],
		$readchar: ['r_cons_readchar', _.int, []],
		$any_key: ['r_cons_any_key', _.void, []],
		$get_size: ['r_cons_get_size', _.int, [_.int]],
		$yesno: ['r_cons_yesno', _.bool, [_.bool, _.CString], 'variadic'],
		$html_print: ['r_cons_html_print', _.int, [_.CString]],
		$arrow_to_hjkl: ['r_cons_arrow_to_hjkl', _.int, [_.int]],
		$get_buffer: ['r_cons_get_buffer', _.CString, []],
		$grep: ['r_cons_grep', _.void, [_.CString]],
		$invert: ['r_cons_invert', _.void, [_.bool, _.int]]
	}];},
	RLine: function() {return [{}, {
		$singleton: ['r_line_singleton', _.ref(_.RLine), []],
		$readline: ['r_line_readline', _.bool, []],
		$set_prompt: ['r_line_set_prompt', _.void, [_.CString]],
		$hist_load: ['r_line_hist_load', _.bool, [_.CString]],
		$hist_add: ['r_line_hist_add', _.bool, [_.CString]],
		$hist_save: ['r_line_hist_save', _.bool, [_.CString]]
	}];},
	RAnalCaseOp: function() {return [{
		addr: _.uint64,
		jump: _.uint64,
		value: _.uint64,
		cond: _.uint32,
		bb_ref_to: _.uint64,
		bb_ref_from: _.uint64
	}, {
		delete: ['free', _.void, [_.ref(_.RAnalCaseOp)]]
	}];},
	RAnalSwitchOp: function() {return [{
		addr: _.uint64,
		min_val: _.uint64,
		def_val: _.uint64,
		max_val: _.uint32,
		cases: _.ref(_.RList(_.ref(_.RAnalCaseOp)))
	}, {
		delete: ['r_anal_switch_op_free', _.void, [_.ref(_.RAnalSwitchOp)]],
		$constructor: ['r_anal_switch_op_new', _.ref(_.RAnalSwitchOp), [_.uint64, _.uint64, _.uint64]],
		add_case: ['r_anal_switch_op_add_case', _.ref(_.RAnalCaseOp), [_.ref(_.RAnalSwitchOp), _.uint64, _.uint64, _.uint64]]
	}];},
	RAnalValue: function() {return [{
		absolute: _.bool,
		memref: _.bool,
		base: _.uint64,
		delta: _.int64,
		imm: _.int64,
		mul: _.int,
		reg: _.ref(_.RRegItem),
		regdelta: _.ref(_.RRegItem)
	}, {
		delete: ['r_anal_value_free', _.void, [_.ref(_.RAnalValue)]]
	}];},
	RAnalCond: function() {return [{
		type: _.int,
		arg: _.array(_.ref(_.RAnalValue), 2)
	}, {
		delete: ['r_anal_cond_free', _.void, [_.ref(_.RAnalCond)]]
	}];},
	RAnalState: function() {return [{
		start: _.uint64,
		end: _.uint64,
		buf: _.ptr(_.uint8),
		len: _.uint64,
		bytes_consumed: _.uint64,
		last_addr: _.uint64,
		current_addr: _.uint64,
		next_addr: _.uint64,
		bbs: _.ref(_.RList(_.ref(_.RAnalBlock))),
		ht_sz: _.uint64,
		current_fcn: _.ref(_.RAnalFunction),
		current_op: _.ref(_.RAnalOp),
		current_bb: _.ref(_.RAnalBlock),
		current_bb_head: _.ref(_.RAnalBlock),
		done: _.uint8,
		anal_ret_val: _.int,
		current_depth: _.uint32,
		max_depth: _.uint32,
		user_state: _.ptr(_.void)
	}, {
		delete: ['r_anal_state_free', _.void, [_.ref(_.RAnalState)]],
		$constructor: ['r_anal_state_new', _.ref(_.RAnalState), [_.uint64, _.ptr(_.uint8), _.uint64]],
		insert_bb: ['r_anal_state_insert_bb', _.void, [_.ref(_.RAnalState), _.ptr(_.RAnalBlock)]],
		search_bb: ['r_anal_state_search_bb', _.ref(_.RAnalBlock), [_.ref(_.RAnalState), _.uint64]],
		get_len: ['r_anal_state_get_len', _.uint64, [_.ref(_.RAnalState), _.uint64]],
		addr_is_valid: ['r_anal_state_addr_is_valid', _.int, [_.ref(_.RAnalState), _.uint64]],
		set_depth: ['r_anal_state_set_depth', _.void, [_.ref(_.RAnalState), _.uint32]]
	}];},
	RAnalBlock: function() {return [{
		name: _.ptr(_.char),
		addr: _.uint64,
		size: _.uint64,
		jump: _.uint64,
		type2: _.uint64,
		fail: _.uint64,
		type: _.int,
		type_ex: _.int,
		ninstr: _.int,
		returnbb: _.bool,
		conditional: _.bool,
		traced: _.bool,
		label: _.ptr(_.char),
		fingerprint: _.ptr(_.uint8),
		diff: _.ref(_.RAnalDiff),
		cond: _.ref(_.RAnalCond),
		switch_op: _.ref(_.RAnalSwitchOp),
		op_bytes: _.array(_.uint8, 30),
		op_sz: _.uint8,
		eflags: _.uint64,
		head: _.ref(_.RAnalBlock),
		tail: _.ref(_.RAnalBlock),
		next: _.ref(_.RAnalBlock),
		prev: _.ref(_.RAnalBlock),
		failbb: _.ref(_.RAnalBlock),
		jumpbb: _.ref(_.RAnalBlock)
	}, {
		delete: ['r_anal_bb_free', _.void, [_.ref(_.RAnalBlock)]]
	}];},
	RAnalOp: function() {return [{
		mnemonic: _.CString,
		addr: _.uint64,
		type: _.int,
		stackop: _.bool,
		cond: _.int,
		size: _.int,
		nopcode: _.int,
		family: _.int,
		eob: _.bool,
		delay: _.int,
		jump: _.uint64,
		fail: _.uint64,
		selector: _.uint32,
		ptr: _.int64,
		val: _.uint64,
		stackptr: _.int64,
		refptr: _.bool,
		src: _.array(_.ref(_.RAnalValue), 3),
		dst: _.ref(_.RAnalValue)
	}, {
		delete: ['r_anal_op_free', _.void, [_.ref(_.RAnalOp)]]
	}];},
	RAnalDiff: function() {return [{
		type: _.int,
		name: _.CString,
		addr: _.uint64
	}, {
		delete: ['r_anal_diff_free', _.void, [_.ref(_.RAnalDiff)]]
	}];},
	RAnalFunction: function() {return [{
		name: _.CString,
		dsc: _.CString,
		size: _.int,
		bits: _.int,
		type: _.short,
		rets: _.short,
		fmod: _.short,
		call: _.short,
		attr: _.CString,
		addr: _.uint64,
		stack: _.int,
		ninstr: _.int,
		nargs: _.int,
		depth: _.int,
		diff: _.ref(_.RAnalDiff),
		fingerprint: _.ptr(_.uint8),
		bbs: _.ref(_.RList(_.ref(_.RAnalBlock))),
		vars: _.ref(_.RList(_.ref(_.RAnalVar))),
		refs: _.ref(_.RList(_.ref(_.RAnalRef))),
		xrefs: _.ref(_.RList(_.ref(_.RAnalRef)))
	}, {
		get_bbs: ['r_anal_fcn_get_bbs', _.ref(_.RList(_.ref(_.RAnalBlock))), [_.ref(_.RAnalFunction)]],
		get_vars: ['r_anal_fcn_get_vars', _.ref(_.RList(_.ref(_.RAnalVar))), [_.ref(_.RAnalFunction)]],
		get_refs: ['r_anal_fcn_get_refs', _.ref(_.RList(_.ref(_.RAnalRef))), [_.ref(_.RAnalFunction)]],
		get_xrefs: ['r_anal_fcn_get_xrefs', _.ref(_.RList(_.ref(_.RAnalRef))), [_.ref(_.RAnalFunction)]]
	}];},
	RAnalVar: function() {return [{
		name: _.CString,
		type: _.CString,
		delta: _.int,
		accesses: _.ref(_.RList(_.ref(_.RAnalVarAccess)))
	}, {
		delete: ['r_anal_var_free', _.void, [_.ref(_.RAnalVar)]]
	}];},
	RAnalVarAccess: function() {return [{
		addr: _.uint64,
		set: _.bool
	}, {
		delete: ['r_anal_var_access_free', _.void, [_.ref(_.RAnalVarAccess)]]
	}];},
	RAnalRef: function() {return [{
		type: _.int,
		addr: _.uint64,
		at: _.uint64
	}, {}];},
	RAnalRefline: function() {return [{
		from: _.uint64,
		to: _.uint64,
		index: _.int
	}, {}];},
	RAnalMetaItem: function() {return [{
		from: _.uint64,
		to: _.uint64,
		size: _.uint64,
		type: _.int,
		str: _.CString
	}, {
		delete: ['r_meta_item_free', _.void, [_.ref(_.RAnalMetaItem)]]
	}];},
	RAnal: function() {return [{
		bits: _.int,
		big_endian: _.bool,
		split: _.bool,
		user: _.ptr(_.void),
		fcns: _.ref(_.RList(_.ref(_.RAnalFunction))),
		meta: _.ref(_.RList(_.ref(_.RAnalMetaItem))),
		reg: _.ref(_.RReg),
		syscall: _.ref(_.RSyscall)
	}, {
		$Cnd: {}/*types.Enum*/,
		$FunctionType: {}/*types.Enum*/,
		$BlockType: {}/*types.Enum*/,
		$BlockDiff: {}/*types.Enum*/,
		$ReflineType: {}/*types.Enum*/,
		$Ret: {}/*types.Enum*/,
		$Stack: {}/*types.Enum*/,
		$Data: {}/*types.Enum*/,
		$OpFamily: {}/*types.Enum*/,
		$VarDir: {}/*types.Enum*/,
		$OpType: {}/*types.Enum*/,
		$MetaWhere: {}/*types.Enum*/,
		$MetaType: {}/*types.Enum*/,
		delete: ['r_anal_free', _.void, [_.ref(_.RAnal)]],
		$constructor: ['r_anal_new', _.ref(_.RAnal), []],
		op_hexstr: ['r_anal_op_hexstr', _.bool, [_.ref(_.RAnal), _.uint64, _.CString]],
		esil_eval: ['r_anal_esil_eval', _.bool, [_.ref(_.RAnal), _.CString]],
		set_bits: ['r_anal_set_bits', _.bool, [_.ref(_.RAnal), _.int]],
		set_big_endian: ['r_anal_set_big_endian', _.bool, [_.ref(_.RAnal), _.bool]],
		diff_setup: ['r_anal_diff_setup', _.void, [_.ref(_.RAnal), _.bool, _.double, _.double]],
		diff_setup_i: ['r_anal_diff_setup_i', _.void, [_.ref(_.RAnal), _.bool, _.int, _.int]],
		get_fcns: ['r_anal_get_fcns', _.ref(_.RList(_.ref(_.RAnalFunction))), [_.ref(_.RAnal)]],
		get_fcn_at: ['r_anal_get_fcn_at', _.ref(_.RAnalFunction), [_.ref(_.RAnal), _.uint64]],
		trace_bb: ['r_anal_trace_bb', _.void, [_.ref(_.RAnal), _.uint64]],
		bb: ['r_anal_bb', _.void, [_.ref(_.RAnal), _.ref(_.RAnalBlock), _.uint64, _.ptr(_.uint8), _.uint64, _.bool]],
		bb_from_offset: ['r_anal_bb_from_offset', _.ref(_.RAnalBlock), [_.ref(_.RAnal), _.uint64]],
		op_to_string: ['r_anal_op_to_string', _.CString, [_.ref(_.RAnal), _.ref(_.RAnalOp)]],
		op_to_esil_string: ['r_anal_op_to_esil_string', _.CString, [_.ref(_.RAnal), _.ref(_.RAnalOp)]],
		meta_add: ['r_meta_add', _.bool, [_.ref(_.RAnal), _.int, _.uint64, _.uint64, _.CString]],
		meta_del: ['r_meta_del', _.bool, [_.ref(_.RAnal), _.int, _.uint64, _.uint64, _.CString]],
		meta_find: ['r_meta_find', _.ref(_.RAnalMetaItem), [_.ref(_.RAnal), _.uint64, _.int, _.int]],
		meta_cleanup: ['r_meta_cleanup', _.bool, [_.ref(_.RAnal), _.uint64, _.uint64]],
		$meta_type_to_string: ['r_meta_type_to_string', _.CString, [_.int]],
		meta_list: ['r_meta_list', _.int, [_.ref(_.RAnal), _.int, _.uint64]]
	}];},
	RSign: function() {return [{}, {
		delete: ['r_sign_free', _.void, [_.ref(_.RSign)]],
		$constructor: ['r_sign_new', _.ref(_.RSign), []]
	}];},
	RRegItem: function() {return [{
		name: _.CString,
		size: _.int,
		offset: _.int,
		packed_size: _.int,
		type: _.int
	}, {}];},
	RRegArena: function() {return [{
		bytes: _.ptr(_.uint8),
		size: _.int
	}, {}];},
	RRegSet: function() {return [{
		arena: _.ref(_.RRegArena),
		regs: _.ref(_.RList(_.ptr(_.RRegItem)))
	}, {}];},
	RReg: function() {return [{}, {
		$Type: {}/*types.Enum*/,
		delete: ['r_reg_free', _.void, [_.ref(_.RReg)]],
		$constructor: ['r_reg_new', _.ref(_.RReg), []],
		set_profile: ['r_reg_set_profile', _.bool, [_.ref(_.RReg), _.CString]],
		set_profile_string: ['r_reg_set_profile_string', _.bool, [_.ref(_.RReg), _.CString]],
		get: ['r_reg_get', _.ref(_.RRegItem), [_.ref(_.RReg), _.CString, _.int]],
		set_name: ['r_reg_set_name', _.bool, [_.ref(_.RReg), _.int, _.CString]],
		get_name: ['r_reg_get_name', _.CString, [_.ref(_.RReg), _.int]],
		$get_name_idx: ['r_reg_get_name_idx', _.int, [_.CString]],
		$type_by_name: ['r_reg_type_by_name', _.int, [_.CString]],
		$get_type: ['r_reg_get_type', _.CString, [_.int]],
		get_value: ['r_reg_get_value', _.uint64, [_.ref(_.RReg), _.ref(_.RRegItem)]],
		set_value: ['r_reg_set_value', _.bool, [_.ref(_.RReg), _.ref(_.RRegItem), _.uint64]],
		get_fvalue: ['r_reg_get_fvalue', _.float, [_.ref(_.RReg), _.ref(_.RRegItem)]],
		set_fvalue: ['r_reg_set_fvalue', _.bool, [_.ref(_.RReg), _.ref(_.RRegItem), _.float]],
		get_pvalue: ['r_reg_get_pvalue', _.uint64, [_.ref(_.RReg), _.ref(_.RRegItem), _.int]],
		set_pvalue: ['r_reg_set_pvalue', _.bool, [_.ref(_.RReg), _.ref(_.RRegItem), _.uint64, _.int]],
		get_bytes: ['r_reg_get_bytes', _.ptr(_.uint8), [_.ref(_.RReg), _.int, _.int]],
		set_bytes: ['r_reg_set_bytes', _.int, [_.ref(_.RReg), _.int, _.ptr(_.uint8), _.int]],
		fit_arena: ['r_reg_fit_arena', _.void, [_.ref(_.RReg)]],
		arena_set: ['r_reg_arena_set', _.void, [_.ref(_.RReg), _.int, _.bool]],
		arena_push: ['r_reg_arena_push', _.bool, [_.ref(_.RReg)]],
		arena_pop: ['r_reg_arena_pop', _.void, [_.ref(_.RReg)]]
	}];},
	RHash: function() {return [{}, {
		$Algorithm: {}/*types.Enum*/,
		$Size: {}/*types.Enum*/,
		delete: ['r_hash_free', _.void, [_.ref(_.RHash)]],
		$constructor: ['r_hash_new', _.ref(_.RHash), [_.bool, _.int]],
		$crc16: ['r_hash_crc16', _.uint16, [_.uint16, _.ptr(_.uint8), _.uint64]],
		$crc32: ['r_hash_crc32', _.uint32, [_.ptr(_.uint8), _.uint64]],
		$xor: ['r_hash_xor', _.uint16, [_.ptr(_.uint8), _.uint64]],
		$xorpair: ['r_hash_xorpair', _.uint32, [_.ptr(_.uint8), _.uint64]],
		$parity: ['r_hash_parity', _.uint8, [_.ptr(_.uint8), _.uint64]],
		$mod255: ['r_hash_mod255', _.uint8, [_.ptr(_.uint8), _.uint64]],
		$hamdist: ['r_hash_hamdist', _.uint8, [_.ptr(_.uint8), _.uint64]],
		$entropy: ['r_hash_entropy', _.double, [_.ptr(_.uint8), _.uint64]],
		$pcprint: ['r_hash_pcprint', _.int, [_.ptr(_.uint8), _.uint64]],
		do_md4: ['r_hash_do_md4', _.ptr(_.uint8), [_.ref(_.RHash), _.ptr(_.uint8), _.uint32]],
		do_md5: ['r_hash_do_md5', _.ptr(_.uint8), [_.ref(_.RHash), _.ptr(_.uint8), _.uint32]],
		do_sha1: ['r_hash_do_sha1', _.ptr(_.uint8), [_.ref(_.RHash), _.ptr(_.uint8), _.uint32]],
		do_sha256: ['r_hash_do_sha256', _.ptr(_.uint8), [_.ref(_.RHash), _.ptr(_.uint8), _.uint32]],
		do_sha384: ['r_hash_do_sha384', _.ptr(_.uint8), [_.ref(_.RHash), _.ptr(_.uint8), _.uint32]],
		do_sha512: ['r_hash_do_sha512', _.ptr(_.uint8), [_.ref(_.RHash), _.ptr(_.uint8), _.uint32]]
	}];},
	REggPlugin: function() {return [{
		name: _.CString,
		desc: _.CString,
		type: _.int
	}, {}];},
	REgg: function() {return [{
		arch: _.int,
		endian: _.int,
		bits: _.int,
		os: _.uint32
	}, {
		delete: ['r_egg_free', _.void, [_.ref(_.REgg)]],
		$constructor: ['r_egg_new', _.ref(_.REgg), []],
		to_string: ['r_egg_to_string', _.CString, [_.ref(_.REgg)]],
		reset: ['r_egg_reset', _.void, [_.ref(_.REgg)]],
		setup: ['r_egg_setup', _.bool, [_.ref(_.REgg), _.CString, _.int, _.bool, _.CString]],
		load: ['r_egg_load', _.void, [_.ref(_.REgg), _.CString, _.int]],
		syscall: ['r_egg_syscall', _.void, [_.ref(_.REgg), _.CString], 'variadic'],
		alloc: ['r_egg_alloc', _.void, [_.ref(_.REgg), _.int]],
		label: ['r_egg_label', _.void, [_.ref(_.REgg), _.CString]],
		include: ['r_egg_include', _.void, [_.ref(_.REgg), _.CString, _.int]],
		raw: ['r_egg_raw', _.bool, [_.ref(_.REgg), _.ptr(_.uint8), _.int]],
		encode: ['r_egg_encode', _.bool, [_.ref(_.REgg), _.CString]],
		shellcode: ['r_egg_shellcode', _.bool, [_.ref(_.REgg), _.CString]],
		option_set: ['r_egg_option_set', _.void, [_.ref(_.REgg), _.CString, _.CString]],
		option_get: ['r_egg_option_get', _.CString, [_.ref(_.REgg), _.CString]],
		padding: ['r_egg_padding', _.bool, [_.ref(_.REgg), _.CString]],
		compile: ['r_egg_compile', _.bool, [_.ref(_.REgg)]],
		assemble: ['r_egg_assemble', _.bool, [_.ref(_.REgg)]],
		get_source: ['r_egg_get_source', _.CString, [_.ref(_.REgg)]],
		get_bin: ['r_egg_get_bin', _.ref(_.RBuffer), [_.ref(_.REgg)]],
		get_assembly: ['r_egg_get_assembly', _.CString, [_.ref(_.REgg)]],
		append: ['r_egg_append', _.void, [_.ref(_.REgg), _.CString]],
		run: ['r_egg_run', _.int, [_.ref(_.REgg)]]
	}];},
	RAsmOp: function() {return [{
		size: _.int,
		payload: _.int,
		buf: _.array(_.uint8, 1024),
		buf_asm: _.array(_.char, 1024),
		buf_hex: _.array(_.char, 1024),
		buf_err: _.array(_.char, 1024)
	}, {
		get_hex: ['r_asm_op_get_hex', _.CString, [_.RAsmOp]],
		get_asm: ['r_asm_op_get_asm', _.CString, [_.RAsmOp]]
	}];},
	RAsmCode: function() {return [{
		len: _.int,
		buf: _.ptr(_.uint8),
		buf_hex: _.CString,
		buf_asm: _.CString
	}, {
		delete: ['r_asm_code_free', _.void, [_.ref(_.RAsmCode)]]
	}];},
	RAsmPlugin: function() {return [{
		name: _.CString,
		arch: _.CString,
		desc: _.CString,
		license: _.CString,
		bits: _.int
	}, {}];},
	RAsm: function() {return [{
		bits: _.int,
		big_endian: _.bool,
		syntax: _.int,
		pc: _.uint64,
		plugins: _.ref(_.RList(_.ref(_.RAsmPlugin)))
	}, {
		$Arch: {}/*types.Enum*/,
		$Syntax: {}/*types.Enum*/,
		$Mod: {}/*types.Enum*/,
		delete: ['r_asm_free', _.void, [_.ref(_.RAsm)]],
		$constructor: ['r_asm_new', _.ref(_.RAsm), []],
		use: ['r_asm_use', _.bool, [_.ref(_.RAsm), _.CString]],
		set_bits: ['r_asm_set_bits', _.bool, [_.ref(_.RAsm), _.int]],
		set_syntax: ['r_asm_set_syntax', _.bool, [_.ref(_.RAsm), _.int]],
		set_pc: ['r_asm_set_pc', _.bool, [_.ref(_.RAsm), _.uint64]],
		set_big_endian: ['r_asm_set_big_endian', _.bool, [_.ref(_.RAsm), _.bool]],
		disassemble: ['r_asm_disassemble', _.int, [_.ref(_.RAsm), _.RAsmOp, _.ptr(_.uint8), _.int]],
		assemble: ['r_asm_assemble', _.int, [_.ref(_.RAsm), _.RAsmOp, _.CString]],
		mdisassemble: ['r_asm_mdisassemble', _.ref(_.RAsmCode), [_.ref(_.RAsm), _.ptr(_.uint8), _.int]],
		mdisassemble_hexstr: ['r_asm_mdisassemble_hexstr', _.ref(_.RAsmCode), [_.ref(_.RAsm), _.CString]],
		massemble: ['r_asm_massemble', _.ref(_.RAsmCode), [_.ref(_.RAsm), _.CString]],
		assemble_file: ['r_asm_assemble_file', _.ref(_.RAsmCode), [_.ref(_.RAsm), _.CString]],
		filter_input: ['r_asm_filter_input', _.bool, [_.ref(_.RAsm), _.CString]],
		filter_output: ['r_asm_filter_output', _.bool, [_.ref(_.RAsm), _.CString]],
		free: ['r_asm_free', _.void, [_.ref(_.RAsm)]]
	}];},
	RSyscallItem: function() {return [{
		name: _.CString,
		swi: _.int,
		num: _.int,
		args: _.int,
		sargs: _.CString
	}, {}];},
	RSyscall: function() {return [{}, {
		delete: ['r_syscall_free', _.void, [_.ref(_.RSyscall)]],
		$constructor: ['r_syscall_new', _.ref(_.RSyscall), []],
		setup: ['r_syscall_setup', _.void, [_.ref(_.RSyscall), _.CString, _.CString, _.int]],
		setup_file: ['r_syscall_setup_file', _.void, [_.ref(_.RSyscall), _.CString]],
		get: ['r_syscall_get', _.ref(_.RSyscallItem), [_.ref(_.RSyscall), _.int, _.int]],
		get_num: ['r_syscall_get_num', _.int, [_.ref(_.RSyscall), _.CString]],
		get_i: ['r_syscall_get_i', _.CString, [_.ref(_.RSyscall), _.int, _.int]],
		list: ['r_syscall_list', _.void, [_.ref(_.RSyscall)]]
	}];},
	RDatabase: function() {return [{}, {
		delete: ['r_db_free', _.void, [_.ref(_.RDatabase)]],
		$constructor: ['r_db_new', _.ref(_.RDatabase), []],
		free: ['r_db_free', _.void, [_.ref(_.RDatabase)]],
		add_id: ['r_db_add_id', _.int, [_.ref(_.RDatabase), _.int, _.int]],
		add: ['r_db_add', _.bool, [_.ref(_.RDatabase), _.ptr(_.void)]],
		add_unique: ['r_db_add_unique', _.bool, [_.ref(_.RDatabase), _.ptr(_.void)]],
		delete: ['r_db_delete', _.bool, [_.ref(_.RDatabase), _.ptr(_.void)]],
		get: ['r_db_get', _.ptr(_.void), [_.ref(_.RDatabase), _.int, _.ptr(_.uint8)]]
	}];},
	RPair: function() {return [{}, {
		delete: ['r_pair_free', _.void, [_.ref(_.RPair)]],
		$constructor: ['r_pair_new', _.ref(_.RPair), []],
		$constructor: ['r_pair_new_from_file', _.ref(_.RPair), [_.CString]],
		free: ['r_pair_free', _.void, [_.ref(_.RPair)]],
		delete: ['r_pair_delete', _.void, [_.ref(_.RPair), _.CString]],
		get: ['r_pair_get', _.CString, [_.ref(_.RPair), _.CString]],
		set: ['r_pair_set', _.void, [_.ref(_.RPair), _.CString, _.CString]],
		sync: ['r_pair_sync', _.void, [_.ref(_.RPair)]],
		reset: ['r_pair_reset', _.void, [_.ref(_.RPair)]]
	}];},
	RIOPlugin: function() {return [{
		name: _.CString,
		desc: _.CString
	}, {}];},
	RIOMap: function() {return [{
		fd: _.int,
		flags: _.int,
		delta: _.uint64,
		from: _.uint64,
		to: _.uint64
	}, {}];},
	RIOSection: function() {return [{
		name: _.CString,
		offset: _.uint64,
		vaddr: _.uint64,
		size: _.uint64,
		vsize: _.uint64,
		rwx: _.int,
		id: _.int
	}, {}];},
	RIODesc: function() {return [{
		fd: _.int,
		flags: _.int,
		name: _.CString
	}, {}];},
	RIO: function() {return [{
		fd: _.ref(_.RIODesc),
		cached: _.bool,
		cached_read: _.bool,
		enforce_rwx: _.bool,
		enforce_seek: _.bool,
		off: _.uint64,
		debug: _.bool,
		va: _.uint64
	}, {
		$Perm: {}/*types.Enum*/,
		$Seek: {}/*types.Enum*/,
		delete: ['r_io_free', _.void, [_.ref(_.RIO)]],
		$constructor: ['r_io_new', _.ref(_.RIO), []],
		free: ['r_io_free', _.ref(_.RIO), [_.ref(_.RIO)]],
		set_write_mask: ['r_io_set_write_mask', _.bool, [_.ref(_.RIO), _.ptr(_.uint8), _.int]],
		open: ['r_io_open', _.ref(_.RIODesc), [_.ref(_.RIO), _.CString, _.int, _.int]],
		open_as: ['r_io_open_as', _.ref(_.RIODesc), [_.ref(_.RIO), _.CString, _.CString, _.int, _.int]],
		redirect: ['r_io_redirect', _.int, [_.ref(_.RIO), _.CString]],
		set_fd: ['r_io_set_fd', _.int, [_.ref(_.RIO), _.ref(_.RIODesc)]],
		read: ['r_io_read', _.int, [_.ref(_.RIO), _.ptr(_.uint8), _.int]],
		read_at: ['r_io_read_at', _.int, [_.ref(_.RIO), _.uint64, _.ptr(_.uint8), _.int]],
		read_buf: ['r_io_read_buf', _.ptr(_.RBuffer), [_.ref(_.RIO), _.uint64, _.int]],
		write: ['r_io_write', _.int, [_.ref(_.RIO), _.ptr(_.uint8), _.int]],
		write_at: ['r_io_write_at', _.int, [_.ref(_.RIO), _.uint64, _.ptr(_.uint8), _.int]],
		seek: ['r_io_seek', _.uint64, [_.ref(_.RIO), _.uint64, _.int]],
		system: ['r_io_system', _.int, [_.ref(_.RIO), _.CString]],
		close: ['r_io_close', _.int, [_.ref(_.RIO), _.ref(_.RIODesc)]],
		size: ['r_io_size', _.uint64, [_.ref(_.RIO)]],
		cache_commit: ['r_io_cache_commit', _.void, [_.ref(_.RIO)]],
		cache_init: ['r_io_cache_init', _.void, [_.ref(_.RIO)]],
		cache_list: ['r_io_cache_list', _.int, [_.ref(_.RIO), _.bool]],
		cache_reset: ['r_io_cache_reset', _.void, [_.ref(_.RIO), _.bool]],
		cache_enable: ['r_io_cache_enable', _.void, [_.ref(_.RIO), _.bool, _.bool]],
		cache_write: ['r_io_cache_write', _.void, [_.ref(_.RIO), _.uint64, _.ptr(_.uint8), _.int]],
		cache_read: ['r_io_cache_read', _.void, [_.ref(_.RIO), _.uint64, _.ptr(_.uint8), _.int]],
		undo_init: ['r_io_undo_init', _.bool, [_.ref(_.RIO)]],
		undo_enable: ['r_io_undo_enable', _.void, [_.ref(_.RIO), _.bool, _.bool]],
		plugin_open: ['r_io_plugin_open', _.bool, [_.ref(_.RIO), _.int, _.ref(_.RIOPlugin)]],
		plugin_close: ['r_io_plugin_close', _.bool, [_.ref(_.RIO), _.int, _.ref(_.RIOPlugin)]],
		plugin_add: ['r_io_plugin_add', _.bool, [_.ref(_.RIO), _.ref(_.RIOPlugin)]],
		plugin_generate: ['r_io_plugin_generate', _.int, [_.ref(_.RIO)]],
		plugin_list: ['r_io_plugin_list', _.void, [_.ref(_.RIO)]],
		map_resolve: ['r_io_map_resolve', _.ref(_.RIOMap), [_.ref(_.RIO), _.int]],
		map_add: ['r_io_map_add', _.bool, [_.ref(_.RIO), _.int, _.int, _.uint64, _.uint64, _.uint64]],
		map_del: ['r_io_map_del', _.bool, [_.ref(_.RIO), _.int]],
		section_next: ['r_io_section_next', _.uint64, [_.ref(_.RIO), _.uint64]],
		section_list: ['r_io_section_list', _.void, [_.ref(_.RIO), _.uint64, _.bool]],
		section_list_visual: ['r_io_section_list_visual', _.void, [_.ref(_.RIO), _.uint64, _.uint64]],
		section_get: ['r_io_section_get', _.ref(_.RIOSection), [_.ref(_.RIO), _.uint64]],
		section_get_offset: ['r_io_section_get_offset', _.uint64, [_.ref(_.RIO), _.uint64]],
		section_get_vaddr: ['r_io_section_get_vaddr', _.uint64, [_.ref(_.RIO), _.uint64]],
		section_get_rwx: ['r_io_section_get_rwx', _.int, [_.ref(_.RIO), _.uint64]],
		section_overlaps: ['r_io_section_overlaps', _.bool, [_.ref(_.RIO), _.ref(_.RIOSection)]],
		section_vaddr_to_offset: ['r_io_section_vaddr_to_offset', _.uint64, [_.ref(_.RIO), _.uint64]],
		section_offset_to_vaddr: ['r_io_section_offset_to_vaddr', _.uint64, [_.ref(_.RIO), _.uint64]],
		desc_add: ['r_io_desc_add', _.void, [_.ref(_.RIO), _.ptr(_.RIODesc)]],
		desc_del: ['r_io_desc_del', _.bool, [_.ref(_.RIO), _.int]]
	}];},
	RBreakpointItem: function() {return [{
		addr: _.uint64,
		size: _.int,
		rwx: _.int,
		hw: _.int,
		trace: _.int,
		enabled: _.int,
		recoil: _.int,
		obytes: _.ptr(_.uint8),
		bbytes: _.ptr(_.uint8),
		data: _.ptr(_.char),
		pids: _.ptr(_.int)
	}, {}];},
	RBreakpointTrace: function() {return [{
		addr: _.uint64,
		addr_end: _.uint64,
		traps: _.ptr(_.uint8),
		buf: _.ptr(_.uint8),
		bits: _.ptr(_.uint8),
		length: _.int,
		bitlen: _.int
	}, {}];},
	RBreakpoint: function() {return [{
		bps: _.ref(_.RList(_.ref(_.RBreakpointItem))),
		traces: _.ref(_.RList(_.ref(_.RBreakpointTrace)))
	}, {
		$Protection: {}/*types.Enum*/,
		$Type: {}/*types.Enum*/,
		delete: ['r_bp_free', _.void, [_.ref(_.RBreakpoint)]],
		$constructor: ['r_bp_new', _.ref(_.RBreakpoint), []],
		use: ['r_bp_use', _.bool, [_.ref(_.RBreakpoint), _.CString]],
		enable: ['r_bp_enable', _.void, [_.ref(_.RBreakpoint), _.uint64, _.bool]],
		at_addr: ['r_bp_at_addr', _.ref(_.RBreakpointItem), [_.ref(_.RBreakpoint), _.uint64, _.int]],
		add_sw: ['r_bp_add_sw', _.ref(_.RBreakpointItem), [_.ref(_.RBreakpoint), _.uint64, _.int, _.int]],
		add_hw: ['r_bp_add_hw', _.ref(_.RBreakpointItem), [_.ref(_.RBreakpoint), _.uint64, _.int, _.int]],
		add_fault: ['r_bp_add_fault', _.bool, [_.ref(_.RBreakpoint), _.uint64, _.int, _.int]],
		add_cond: ['r_bp_add_cond', _.int, [_.ref(_.RBreakpoint), _.CString]],
		del: ['r_bp_del', _.bool, [_.ref(_.RBreakpoint), _.uint64]],
		del_cond: ['r_bp_del_cond', _.bool, [_.ref(_.RBreakpoint), _.int]],
		set_trace: ['r_bp_set_trace', _.int, [_.ref(_.RBreakpoint), _.uint64, _.int]],
		restore: ['r_bp_restore', _.int, [_.ref(_.RBreakpoint), _.bool]],
		recoil: ['r_bp_recoil', _.int, [_.ref(_.RBreakpoint), _.uint64]],
		list: ['r_bp_list', _.int, [_.ref(_.RBreakpoint), _.bool]],
		traptrace_enable: ['r_bp_traptrace_enable', _.void, [_.ref(_.RBreakpoint), _.bool]],
		traptrace_reset: ['r_bp_traptrace_reset', _.void, [_.ref(_.RBreakpoint), _.bool]],
		traptrace_next: ['r_bp_traptrace_next', _.uint64, [_.ref(_.RBreakpoint), _.uint64]],
		traptrace_add: ['r_bp_traptrace_add', _.int, [_.ref(_.RBreakpoint), _.uint64, _.uint64]],
		traptrace_free_at: ['r_bp_traptrace_free_at', _.int, [_.ref(_.RBreakpoint), _.uint64]],
		traptrace_list: ['r_bp_traptrace_list', _.void, [_.ref(_.RBreakpoint)]],
		traptrace_at: ['r_bp_traptrace_at', _.int, [_.ref(_.RBreakpoint), _.uint64, _.int]]
	}];},
	RDebugFrame: function() {return [{
		addr: _.uint64,
		size: _.int
	}, {}];},
	RDebugPid: function() {return [{
		pid: _.int,
		status: _.int,
		runnable: _.int,
		path: _.CString
	}, {
		$constructor: ['r_debug_pid_new', _.ref(_.RDebugPid), [_.CString, _.int, _.char, _.uint64]]
	}];},
	RDebugMap: function() {return [{
		name: _.CString,
		addr: _.uint64,
		addr_end: _.uint64,
		size: _.uint64,
		file: _.CString,
		perm: _.int,
		user: _.int
	}, {
		delete: ['r_debug_map_free', _.void, [_.ref(_.RDebugMap)]]
	}];},
	RDebugTrace: function() {return [{
		traces: _.ref(_.RList(_.ref(_.RDebugTracepoint))),
		count: _.int,
		enabled: _.int,
		tag: _.int,
		dup: _.int,
		addresses: _.CString
	}, {}];},
	RDebugTracepoint: function() {return [{
		addr: _.uint64,
		tags: _.uint64,
		tag: _.int,
		size: _.int,
		count: _.int,
		times: _.int,
		stamp: _.uint64
	}, {}];},
	RDebug: function() {return [{
		arch: _.int,
		bits: _.int,
		pid: _.int,
		tid: _.int,
		swstep: _.bool,
		steps: _.int,
		newstate: _.int,
		reason: _.int,
		signum: _.int,
		bp: _.ref(_.RBreakpoint)
	}, {
		$ProcessStatus: {}/*types.Enum*/,
		$Reason: {}/*types.Enum*/,
		delete: ['r_debug_free', _.void, [_.ref(_.RDebug)]],
		$constructor: ['r_debug_new', _.ref(_.RDebug), [_.int]],
		use: ['r_debug_use', _.bool, [_.ref(_.RDebug), _.CString]],
		attach: ['r_debug_attach', _.bool, [_.ref(_.RDebug), _.int]],
		detach: ['r_debug_detach', _.bool, [_.ref(_.RDebug), _.int]],
		start: ['r_debug_start', _.bool, [_.ref(_.RDebug), _.CString]],
		stop_reason: ['r_debug_stop_reason', _.int, [_.ref(_.RDebug)]],
		hold: ['r_debug_wait', _.bool, [_.ref(_.RDebug)]],
		is_dead: ['r_debug_is_dead', _.bool, [_.ref(_.RDebug)]],
		kill: ['r_debug_kill', _.bool, [_.ref(_.RDebug), _.int, _.int, _.int]],
		kill_setup: ['r_debug_kill_setup', _.bool, [_.ref(_.RDebug), _.int, _.int]],
		select: ['r_debug_select', _.bool, [_.ref(_.RDebug), _.int, _.int]],
		step: ['r_debug_step', _.bool, [_.ref(_.RDebug), _.int]],
		step_over: ['r_debug_step_over', _.bool, [_.ref(_.RDebug), _.int]],
		continue: ['r_debug_continue', _.bool, [_.ref(_.RDebug)]],
		continue_kill: ['r_debug_continue_kill', _.bool, [_.ref(_.RDebug), _.int]],
		continue_until: ['r_debug_continue_until', _.bool, [_.ref(_.RDebug), _.uint64]],
		continue_until_optype: ['r_debug_continue_until_optype', _.bool, [_.ref(_.RDebug), _.int, _.int]],
		continue_until_nontraced: ['r_debug_continue_until_nontraced', _.bool, [_.ref(_.RDebug)]],
		continue_syscall: ['r_debug_continue_syscall', _.bool, [_.ref(_.RDebug), _.int]],
		map_dealloc: ['r_debug_map_dealloc', _.bool, [_.ref(_.RDebug), _.ref(_.RDebugMap)]],
		map_list: ['r_debug_map_list', _.void, [_.ref(_.RDebug), _.uint64, _.bool]],
		map_get: ['r_debug_map_get', _.ref(_.RDebugMap), [_.ref(_.RDebug), _.uint64]],
		map_alloc: ['r_debug_map_alloc', _.ref(_.RDebugMap), [_.ref(_.RDebug), _.uint64, _.int]],
		map_sync: ['r_debug_map_sync', _.bool, [_.ref(_.RDebug)]],
		child_fork: ['r_debug_child_fork', _.bool, [_.ref(_.RDebug)]],
		child_clone: ['r_debug_child_clone', _.bool, [_.ref(_.RDebug)]],
		arg_get: ['r_debug_arg_get', _.uint64, [_.ref(_.RDebug), _.int, _.int]],
		arg_set: ['r_debug_arg_set', _.bool, [_.ref(_.RDebug), _.int, _.int, _.uint64]],
		execute: ['r_debug_execute', _.uint64, [_.ref(_.RDebug), _.ptr(_.uint8), _.int, _.bool]],
		desc_open: ['r_debug_desc_open', _.int, [_.ref(_.RDebug), _.CString]],
		desc_close: ['r_debug_desc_close', _.int, [_.ref(_.RDebug), _.int]],
		desc_dup: ['r_debug_desc_dup', _.int, [_.ref(_.RDebug), _.int, _.int]],
		desc_read: ['r_debug_desc_read', _.int, [_.ref(_.RDebug), _.int, _.uint64, _.int]],
		desc_seek: ['r_debug_desc_seek', _.int, [_.ref(_.RDebug), _.int, _.uint64]],
		desc_write: ['r_debug_desc_write', _.int, [_.ref(_.RDebug), _.int, _.uint64, _.int]],
		desc_list: ['r_debug_desc_list', _.int, [_.ref(_.RDebug), _.int]],
		reg_sync: ['r_debug_reg_sync', _.bool, [_.ref(_.RDebug), _.int, _.bool]],
		reg_list: ['r_debug_reg_list', _.bool, [_.ref(_.RDebug), _.int, _.int, _.bool]],
		pids: ['r_debug_pids', _.ref(_.RList(_.ref(_.RDebugPid))), [_.ref(_.RDebug), _.int]],
		pid_list: ['r_debug_pid_list', _.int, [_.ref(_.RDebug), _.int]],
		thread_list: ['r_debug_thread_list', _.int, [_.ref(_.RDebug), _.int]],
		trace_reset: ['r_debug_trace_reset', _.void, [_.ref(_.RDebug)]],
		trace_pc: ['r_debug_trace_pc', _.int, [_.ref(_.RDebug)]],
		trace_at: ['r_debug_trace_at', _.void, [_.ref(_.RDebug), _.CString]],
		trace_list: ['r_debug_trace_list', _.void, [_.ref(_.RDebug), _.int]],
		trace_tag: ['r_debug_trace_tag', _.bool, [_.ref(_.RDebug), _.int]]
	}];},
	RDiffOp: function() {return [{
		a_off: _.uint64,
		a_buf: _.ptr(_.uint8),
		a_len: _.int,
		b_off: _.uint64,
		b_buf: _.ptr(_.uint8),
		b_len: _.int
	}, {}];},
	RDiff: function() {return [{}, {
		delete: ['r_diff_free', _.void, [_.ref(_.RDiff)]],
		$constructor: ['r_diff_new', _.ref(_.RDiff), [_.uint64, _.uint64]],
		buffers: ['r_diff_buffers', _.int, [_.ref(_.RDiff), _.ptr(_.uint8), _.int, _.ptr(_.uint8), _.int]],
		buffers_distance: ['r_diff_buffers_distance', _.int, [_.ref(_.RDiff), _.ptr(_.uint8), _.int, _.ptr(_.uint8), _.int, _.uint32, _.double]],
		set_delta: ['r_diff_set_delta', _.bool, [_.ref(_.RDiff), _.int]]
	}];},
	RSearchKeyword: function() {return [{
		keyword: _.array(_.char, 128),
		binmask: _.array(_.char, 128),
		bin_keyword: _.array(_.uint8, 128),
		bin_binmask: _.array(_.uint8, 128),
		keyword_length: _.int,
		binmask_length: _.int,
		count: _.int,
		type: _.int
	}, {
		delete: ['free', _.void, [_.ref(_.RSearchKeyword)]],
		$constructor: ['r_search_keyword_new_str', _.ref(_.RSearchKeyword), [_.CString, _.CString, _.CString, _.bool]],
		$constructor: ['r_search_keyword_new', _.ref(_.RSearchKeyword), [_.ptr(_.uint8), _.int, _.ptr(_.uint8), _.int, _.CString]]
	}];},
	RSearchHit: function() {return [{
		kw: _.ref(_.RSearchKeyword),
		addr: _.uint64
	}, {
		delete: ['free', _.void, [_.ref(_.RSearchHit)]]
	}];},
	RSearch: function() {return [{
		kws: _.ref(_.RList(_.ref(_.RSearchKeyword)))
	}, {
		$Mode: {}/*types.Enum*/,
		delete: ['r_search_free', _.void, [_.ref(_.RSearch)]],
		$constructor: ['r_search_new', _.ref(_.RSearch), [_.int]],
		set_mode: ['r_search_set_mode', _.bool, [_.ref(_.RSearch), _.int]],
		begin: ['r_search_begin', _.bool, [_.ref(_.RSearch)]],
		reset: ['r_search_reset', _.void, [_.ref(_.RSearch), _.int]],
		update: ['r_search_update', _.int, [_.ref(_.RSearch), _.uint64, _.ptr(_.uint8), _.long]],
		update_i: ['r_search_update_i', _.int, [_.ref(_.RSearch), _.uint64, _.ptr(_.uint8), _.long]],
		find: ['r_search_find', _.ref(_.RList(_.ref(_.RSearchHit))), [_.ref(_.RSearch), _.uint64, _.ptr(_.uint8), _.int]],
		kw_add: ['r_search_kw_add', _.bool, [_.ref(_.RSearch), _.ref(_.RSearchKeyword)]],
		kw_reset: ['r_search_kw_reset', _.void, [_.ref(_.RSearch)]],
		set_callback: ['r_search_set_callback', _.void, [_.ref(_.RSearch), _.delegate(_.int, [_.ref(_.RSearchKeyword), _.ptr(_.void), _.uint64]), _.ptr(_.void)]],
		strings_update: ['r_search_strings_update', _.int, [_.ref(_.RSearch), _.uint64, _.ptr(_.uint8), _.int]]
	}];},
	RFlagItem: function() {return [{
		name: _.array(_.char, 128),
		namehash: _.uint64,
		space: _.int,
		size: _.uint64,
		offset: _.uint64,
		cmd: _.CString
	}, {
		set_name: ['r_flag_item_set_name', _.void, [_.ref(_.RFlagItem), _.CString]]
	}];},
	RFlag: function() {return [{
		space_idx: _.int,
		flags: _.ref(_.RList(_.ref(_.RFlagItem)))
	}, {
		delete: ['r_flag_free', _.void, [_.ref(_.RFlag)]],
		$constructor: ['r_flag_new', _.ref(_.RFlag), []],
		list: ['r_flag_list', _.void, [_.ref(_.RFlag), _.bool]],
		get: ['r_flag_get', _.ref(_.RFlagItem), [_.ref(_.RFlag), _.CString]],
		get_i: ['r_flag_get_i', _.ref(_.RFlagItem), [_.ref(_.RFlag), _.uint64]],
		unset: ['r_flag_unset', _.bool, [_.ref(_.RFlag), _.CString, _.ref(_.RFlagItem)]],
		unset_i: ['r_flag_unset_i', _.bool, [_.ref(_.RFlag), _.uint64, _.ref(_.RFlagItem)]],
		sort: ['r_flag_sort', _.bool, [_.ref(_.RFlag), _.int]],
		set: ['r_flag_set', _.void, [_.ref(_.RFlag), _.CString, _.uint64, _.int, _.bool]],
		space_list: ['r_flag_space_list', _.bool, [_.ref(_.RFlag), _.int]],
		space_get_i: ['r_flag_space_get_i', _.CString, [_.ref(_.RFlag), _.int]],
		space_get: ['r_flag_space_get', _.int, [_.ref(_.RFlag), _.CString]],
		space_set: ['r_flag_space_set', _.void, [_.ref(_.RFlag), _.CString]]
	}];},
	RConfig: function() {return [{
		lock: _.bool,
		last_notfound: _.int,
		n_nodes: _.int
	}, {
		delete: ['r_config_free', _.void, [_.ref(_.RConfig)]],
		$constructor: ['r_config_new', _.ref(_.RConfig), [_.ptr(_.void)]],
		eval: ['r_config_eval', _.int, [_.ref(_.RConfig), _.CString]],
		get: ['r_config_get', _.CString, [_.ref(_.RConfig), _.CString]],
		get_i: ['r_config_get_i', _.uint64, [_.ref(_.RConfig), _.CString]],
		node_get: ['r_config_node_get', _.ref(_.RConfigNode), [_.ref(_.RConfig), _.CString]],
		$node_new: ['r_config_node_new', _.ref(_.RConfigNode), [_.CString, _.CString]],
		desc: ['r_config_desc', _.CString, [_.ref(_.RConfig), _.CString, _.CString]],
		swap: ['r_config_swap', _.int, [_.ref(_.RConfig), _.CString]],
		set: ['r_config_set', _.ref(_.RConfigNode), [_.ref(_.RConfig), _.CString, _.CString]],
		set_i: ['r_config_set_i', _.ref(_.RConfigNode), [_.ref(_.RConfig), _.CString, _.uint64]],
		list: ['r_config_list', _.void, [_.ref(_.RConfig), _.CString, _.bool]]
	}];},
	RConfigNode: function() {return [{
		name: _.CString,
		hash: _.int,
		flags: _.int,
		value: _.CString,
		i_value: _.uint64
	}, {}];},
	RBinFile: function() {return [{
		buf: _.ref(_.RBuffer),
		file: _.CString,
		size: _.int,
		offset: _.uint64,
		o: _.ref(_.RBinObject),
		curplugin: _.ref(_.RBinPlugin)
	}, {}];},
	RBinPlugin: function() {return [{}, {}];},
	RBinDwarfRow: function() {return [{
		address: _.uint64,
		file: _.CString,
		line: _.int,
		column: _.int
	}, {}];},
	RBinClass: function() {return [{
		name: _.CString,
		super: _.CString,
		index: _.int,
		methods: _.ref(_.RList(_.ref(_.RBinSymbol))),
		fields: _.ref(_.RList(_.ref(_.RBinField))),
		visibility: _.bool
	}, {}];},
	RBinObject: function() {return [{
		baddr: _.uint64,
		size: _.int,
		sections: _.ref(_.RList(_.ref(_.RBinSection))),
		imports: _.ref(_.RList(_.ref(_.RBinImport))),
		symbols: _.ref(_.RList(_.ref(_.RBinSymbol))),
		entries: _.ref(_.RList(_.ref(_.RBinAddr))),
		fields: _.ref(_.RList(_.ref(_.RBinField))),
		libs: _.ref(_.RList(_.ref(_.RBinSymbol))),
		relocs: _.ref(_.RList(_.ref(_.RBinReloc))),
		strings: _.ref(_.RList(_.ref(_.RBinString))),
		classes: _.ref(_.RList(_.ref(_.RBinClass))),
		lines: _.ref(_.RList(_.ref(_.RBinDwarfRow))),
		info: _.ref(_.RBinInfo),
		binsym: _.array(_.ref(_.RBinAddr), 4)
	}, {}];},
	RBinAddr: function() {return [{
		rva: _.uint64,
		offset: _.uint64
	}, {}];},
	RBinSection: function() {return [{
		name: _.array(_.char, 512),
		size: _.uint64,
		vsize: _.uint64,
		rva: _.uint64,
		offset: _.uint64,
		srwx: _.uint64
	}, {}];},
	RBinSymbol: function() {return [{
		name: _.array(_.char, 512),
		forwarder: _.array(_.char, 512),
		bind: _.array(_.char, 512),
		type: _.array(_.char, 512),
		classname: _.CString,
		rva: _.uint64,
		offset: _.uint64,
		size: _.uint64,
		ordinal: _.uint64
	}, {}];},
	RBinImport: function() {return [{
		name: _.array(_.char, 512),
		bind: _.array(_.char, 512),
		type: _.array(_.char, 512),
		ordinal: _.uint64
	}, {}];},
	RBinReloc: function() {return [{
		type: _.uint8,
		additive: _.uint8,
		import: _.ref(_.RBinImport),
		addend: _.int64,
		rva: _.uint64,
		offset: _.uint64
	}, {}];},
	RBinInfo: function() {return [{
		file: _.array(_.char, 512),
		type: _.array(_.char, 512),
		bclass: _.array(_.char, 512),
		rclass: _.array(_.char, 512),
		arch: _.array(_.char, 512),
		machine: _.array(_.char, 512),
		os: _.array(_.char, 512),
		subsystem: _.array(_.char, 512),
		rpath: _.array(_.char, 512),
		lang: _.CString,
		bits: _.int,
		has_va: _.bool,
		has_pi: _.bool,
		big_endian: _.bool,
		dbg_info: _.uint64
	}, {}];},
	RBinString: function() {return [{
		string: _.array(_.char, 512),
		rva: _.uint64,
		offset: _.uint64,
		ordinal: _.uint64,
		size: _.uint64
	}, {}];},
	RBinField: function() {return [{
		name: _.array(_.char, 512),
		rva: _.uint64,
		offset: _.uint64
	}, {}];},
	RBin: function() {return [{
		file: _.CString,
		cur: _.ref(_.RBinFile),
		narch: _.int
	}, {
		$Sym: {}/*types.Enum*/,
		$RelocType: {}/*types.Enum*/,
		delete: ['r_bin_free', _.void, [_.ref(_.RBin)]],
		$constructor: ['r_bin_new', _.ref(_.RBin), []],
		wr_scn_resize: ['r_bin_wr_scn_resize', _.uint64, [_.ref(_.RBin), _.CString, _.uint64]],
		wr_rpath_del: ['r_bin_wr_rpath_del', _.int, [_.ref(_.RBin)]],
		wr_output: ['r_bin_wr_output', _.int, [_.ref(_.RBin), _.CString]],
		load: ['r_bin_load', _.int, [_.ref(_.RBin), _.CString, _.uint64, _.uint64, _.bool]],
		create: ['r_bin_create', _.ref(_.RBuffer), [_.ref(_.RBin), _.ptr(_.uint8), _.int, _.ptr(_.uint8), _.int]],
		use_arch: ['r_bin_use_arch', _.int, [_.ref(_.RBin), _.CString, _.int, _.CString]],
		select: ['r_bin_select', _.int, [_.ref(_.RBin), _.CString, _.int, _.CString]],
		select_idx: ['r_bin_select_idx', _.int, [_.ref(_.RBin), _.int]],
		list: ['r_bin_list', _.int, [_.ref(_.RBin)]],
		get_baddr: ['r_bin_get_baddr', _.uint64, [_.ref(_.RBin)]],
		get_sym: ['r_bin_get_sym', _.ref(_.RBinAddr), [_.ref(_.RBin), _.int]],
		get_entries: ['r_bin_get_entries', _.ref(_.RList(_.ref(_.RBinAddr))), [_.ref(_.RBin)]],
		get_fields: ['r_bin_get_fields', _.ref(_.RList(_.ref(_.RBinField))), [_.ref(_.RBin)]],
		get_imports: ['r_bin_get_imports', _.ref(_.RList(_.ref(_.RBinImport))), [_.ref(_.RBin)]],
		get_sections: ['r_bin_get_sections', _.ref(_.RList(_.ref(_.RBinSection))), [_.ref(_.RBin)]],
		get_strings: ['r_bin_get_strings', _.ref(_.RList(_.ref(_.RBinString))), [_.ref(_.RBin)]],
		get_symbols: ['r_bin_get_symbols', _.ref(_.RList(_.ref(_.RBinSymbol))), [_.ref(_.RBin)]],
		get_relocs: ['r_bin_get_relocs', _.ref(_.RList(_.ref(_.RBinReloc))), [_.ref(_.RBin)]],
		get_libs: ['r_bin_get_libs', _.ref(_.RList(_.CString)), [_.ref(_.RBin)]],
		get_info: ['r_bin_get_info', _.ref(_.RBinInfo), [_.ref(_.RBin)]],
		is_big_endian: ['r_bin_is_big_endian', _.int, [_.ref(_.RBin)]],
		is_stripped: ['r_bin_is_stripped', _.int, [_.ref(_.RBin)]],
		is_static: ['r_bin_is_static', _.int, [_.ref(_.RBin)]],
		has_dbg_linenums: ['r_bin_has_dbg_linenums', _.int, [_.ref(_.RBin)]],
		has_dbg_syms: ['r_bin_has_dbg_syms', _.int, [_.ref(_.RBin)]],
		has_dbg_relocs: ['r_bin_has_dbg_relocs', _.int, [_.ref(_.RBin)]],
		meta_get_line: ['r_bin_meta_get_line', _.int, [_.ref(_.RBin), _.uint64, _.CString, _.int, _.int]],
		meta_get_source_line: ['r_bin_meta_get_source_line', _.CString, [_.ref(_.RBin), _.uint64]],
		get_object: ['r_bin_get_object', _.ref(_.RBinObject), [_.ref(_.RBin)]]
	}];},
	RParse: function() {return [{}, {
		delete: ['r_parse_free', _.void, [_.ref(_.RParse)]],
		$constructor: ['r_parse_new', _.ref(_.RParse), []],
		list: ['r_parse_list', _.int, [_.ref(_.RParse)]],
		use: ['r_parse_use', _.bool, [_.ref(_.RParse), _.CString]],
		filter: ['r_parse_filter', _.bool, [_.ref(_.RParse), _.ref(_.RFlag), _.CString, _.CString, _.int]],
		assemble: ['r_parse_assemble', _.bool, [_.ref(_.RParse), _.CString, _.CString]],
		parse: ['r_parse_parse', _.bool, [_.ref(_.RParse), _.CString, _.CString]],
		$c_file: ['r_parse_c_file', _.CString, [_.CString]],
		$c_string: ['r_parse_c_string', _.CString, [_.CString]],
		$is_c_file: ['r_parse_is_c_file', _.bool, [_.CString]]
	}];},
	RLangPlugin: function() {return [{
		name: _.CString,
		desc: _.CString
	}, {}];},
	RLang: function() {return [{
		cur: _.ref(_.RLangPlugin)
	}, {
		delete: ['r_lang_free', _.void, [_.ref(_.RLang)]],
		$constructor: ['r_lang_new', _.ref(_.RLang), []],
		define: ['r_lang_define', _.bool, [_.ref(_.RLang), _.CString, _.CString, _.ptr(_.void)]],
		add: ['r_lang_add', _.bool, [_.ref(_.RLang), _.ref(_.RLangPlugin)]],
		use: ['r_lang_use', _.bool, [_.ref(_.RLang), _.CString]],
		undef: ['r_lang_undef', _.void, [_.ref(_.RLang), _.CString]],
		list: ['r_lang_list', _.bool, [_.ref(_.RLang)]],
		set_argv: ['r_lang_set_argv', _.bool, [_.ref(_.RLang), _.int, _.ptr(_.ptr(_.char))]],
		run: ['r_lang_run', _.bool, [_.ref(_.RLang), _.CString, _.int]],
		run_file: ['r_lang_run_file', _.bool, [_.ref(_.RLang), _.CString]],
		get_by_extension: ['r_lang_get_by_extension', _.ref(_.RLangPlugin), [_.ref(_.RLang), _.CString]],
		get_by_name: ['r_lang_get_by_name', _.ref(_.RLangPlugin), [_.ref(_.RLang), _.CString]],
		prompt: ['r_lang_prompt', _.bool, [_.ref(_.RLang)]]
	}];},
	RPrint: function() {return [{
		width: _.int,
		interrupt: _.bool,
		limit: _.int,
		cur_enabled: _.bool,
		cur: _.int,
		ocur: _.int,
		flags: _.int
	}, {
		delete: ['r_print_free', _.void, [_.ref(_.RPrint)]],
		$constructor: ['r_print_new', _.ref(_.RPrint), []],
		hexpair: ['r_print_hexpair', _.CString, [_.ref(_.RPrint), _.CString, _.int]],
		set_flags: ['r_print_set_flags', _.void, [_.ref(_.RPrint), _.int]],
		hexdump: ['r_print_hexdump', _.void, [_.ref(_.RPrint), _.uint64, _.ptr(_.uint8), _.int, _.int, _.int]],
		hexpairs: ['r_print_hexpairs', _.void, [_.ref(_.RPrint), _.uint64, _.ptr(_.uint8), _.int]],
		bytes: ['r_print_bytes', _.void, [_.ref(_.RPrint), _.ptr(_.uint8), _.int, _.CString]],
		c: ['r_print_c', _.void, [_.ref(_.RPrint), _.ptr(_.uint8), _.int]],
		raw: ['r_print_raw', _.void, [_.ref(_.RPrint), _.ptr(_.uint8), _.int]],
		cursor: ['r_print_cursor', _.void, [_.ref(_.RPrint), _.int, _.int]],
		set_cursor: ['r_print_set_cursor', _.void, [_.ref(_.RPrint), _.int, _.int, _.int]],
		code: ['r_print_code', _.void, [_.ref(_.RPrint), _.uint64, _.ptr(_.uint8), _.int, _.char]],
		date_dos: ['r_print_date_dos', _.int, [_.ref(_.RPrint), _.ptr(_.uint8), _.int]],
		date_w32: ['r_print_date_w32', _.int, [_.ref(_.RPrint), _.ptr(_.uint8), _.int]],
		date_unix: ['r_print_date_unix', _.int, [_.ref(_.RPrint), _.ptr(_.uint8), _.int]]
	}];},
	RFS: function() {return [{
		roots: _.ref(_.RList(_.ref(_.RFSRoot)))
	}, {
		delete: ['r_fs_free', _.void, [_.ref(_.RFS)]],
		$constructor: ['r_fs_new', _.ref(_.RFS), []],
		mount: ['r_fs_mount', _.ref(_.RFSRoot), [_.ref(_.RFS), _.CString, _.CString, _.uint64]],
		view: ['r_fs_view', _.void, [_.ref(_.RFS), _.int]],
		umount: ['r_fs_umount', _.bool, [_.ref(_.RFS), _.CString]],
		root: ['r_fs_root', _.ref(_.RList(_.ref(_.RFSRoot))), [_.ref(_.RFS), _.CString]],
		open: ['r_fs_open', _.ref(_.RFSFile), [_.ref(_.RFS), _.CString]],
		close: ['r_fs_close', _.void, [_.ref(_.RFS), _.ref(_.RFSFile)]],
		read: ['r_fs_read', _.int, [_.ref(_.RFS), _.ref(_.RFSFile), _.uint64, _.int]],
		slurp: ['r_fs_slurp', _.ref(_.RFSFile), [_.ref(_.RFS), _.CString]],
		dir: ['r_fs_dir', _.ref(_.RList(_.ref(_.RFSFile))), [_.ref(_.RFS), _.CString]],
		partitions: ['r_fs_partitions', _.ref(_.RList(_.ref(_.RFSPartition))), [_.ref(_.RFS), _.CString, _.uint64]],
		dir_dump: ['r_fs_dir_dump', _.int, [_.ref(_.RFS), _.CString, _.CString]],
		find_name: ['r_fs_find_name', _.ref(_.RList(_.CString)), [_.ref(_.RFS), _.CString, _.CString]],
		find_off: ['r_fs_find_off', _.ref(_.RList(_.CString)), [_.ref(_.RFS), _.CString, _.uint64]],
		prompt: ['r_fs_prompt', _.bool, [_.ref(_.RFS), _.CString]],
		$partition_type: ['r_fs_partition_type', _.CString, [_.CString, _.int]],
		$partition_type_get: ['r_fs_partition_type_get', _.CString, [_.int]]
	}];},
	RFSFile: function() {return [{
		name: _.CString,
		path: _.CString,
		off: _.uint64,
		size: _.uint32,
		data: _.ptr(_.uint8),
		ctx: _.ptr(_.void),
		type: _.char,
		time: _.uint64,
		p: _.ref(_.RFSPlugin),
		root: _.ref(_.RFSRoot),
		ptr: _.ptr(_.void)
	}, {
		delete: ['r_fs_file_free', _.void, [_.ref(_.RFSFile)]]
	}];},
	RFSPlugin: function() {return [{
		name: _.CString,
		desc: _.CString
	}, {}];},
	RFSRoot: function() {return [{
		path: _.CString,
		delta: _.uint64,
		p: _.ref(_.RFSPlugin),
		ptr: _.ptr(_.void)
	}, {
		delete: ['r_fs_root_free', _.void, [_.ref(_.RFSRoot)]]
	}];},
	RFSPartition: function() {return [{
		number: _.int,
		start: _.uint64,
		length: _.uint64,
		index: _.int,
		type: _.int
	}, {
		delete: ['r_fs_partition_free', _.void, [_.ref(_.RFSPartition)]]
	}];},
	RMagic: function() {return [{}, {
		delete: ['r_magic_free', _.void, [_.ref(_.RMagic)]],
		$constructor: ['r_magic_new', _.ref(_.RMagic), [_.int]],
		file: ['r_magic_file', _.CString, [_.ref(_.RMagic), _.CString]],
		descriptor: ['r_magic_descriptor', _.CString, [_.ref(_.RMagic), _.int]],
		buffer: ['r_magic_buffer', _.CString, [_.ref(_.RMagic), _.ptr(_.void), _.int]],
		load: ['r_magic_load', _.int, [_.ref(_.RMagic), _.CString]],
		check: ['r_magic_check', _.int, [_.ref(_.RMagic), _.CString]],
		compile: ['r_magic_compile', _.int, [_.ref(_.RMagic), _.CString]],
		setflags: ['r_magic_setflags', _.void, [_.ref(_.RMagic), _.int]]
	}];}
});
exports.RLibType = {}/*types.Enum*/;
exports.RLibType.IO = 0;
exports.RLibType.DBG = 1;
exports.RLibType.LANG = 2;
exports.RLibType.ASM = 3;
exports.RLibType.ANAL = 4;
exports.RLibType.PARSE = 5;
exports.RLibType.BIN = 6;
exports.RLibType.BP = 8;
exports.RLibType.SYSCALL = 9;
exports.RLibType.FASTCALL = 10;
exports.RLibType.CRYPTO = 11;
exports.RLibType.CMD = 12;
exports.RLibType.LAST = 14;
exports.ExOpType = {}/*types.Enum*/;
exports.ExOpType.ILL_OP = -1;
exports.ExOpType.NULL_OP = 0;
exports.ExOpType.NOP = 1;
exports.ExOpType.STORE_OP = 1048576;
exports.ExOpType.LOAD_OP = 2097152;
exports.ExOpType.REG_OP = 4194304;
exports.ExOpType.OBJ_OP = 8388608;
exports.ExOpType.STACK_OP = 33554432;
exports.ExOpType.BIN_OP = 67108864;
exports.ExOpType.CODE_OP = 134217728;
exports.ExOpType.DATA_OP = 268435456;
exports.ExOpType.UNK_OP = 536870912;
exports.ExOpType.REP_OP = 1073741824;
exports.ExOpType.COND_OP = -2147483648;
exports.ExDataType = {}/*types.Enum*/;
exports.ExDataType.REF_NULL = 0;
exports.ExDataType.UNK_REF = 2;
exports.ExDataType.REF = 4;
exports.ExDataType.SIGNED = 8;
exports.ExDataType.PRIM = 16;
exports.ExDataType.CONST = 32;
exports.ExDataType.STATIC = 64;
exports.ExDataType.VOLATILE = 128;
exports.ExDataType.PUBLIC = 256;
exports.ExDataType.BOOL = 1024;
exports.ExDataType.BYTE = 2048;
exports.ExDataType.SHORT = 4096;
exports.ExDataType.INT32 = 8192;
exports.ExDataType.INT64 = 16384;
exports.ExDataType.FLOAT = 32768;
exports.ExDataType.DOUBLE = 65536;
exports.ExCodeOp = {}/*types.Enum*/;
exports.ExCodeOp.JMP = 134217730;
exports.ExCodeOp.CALL = 134217732;
exports.ExCodeOp.RET = 134217736;
exports.ExCodeOp.TRAP = 134217744;
exports.ExCodeOp.SWI = 134217760;
exports.ExCodeOp.IO = 134217792;
exports.ExCodeOp.LEAVE = 134217856;
exports.ExCodeOp.SWITCH = 134217984;
exports.ExCodeOp.CJMP = -2013265918;
exports.ExCodeOp.EOB = 134218122;
exports.ExCodeOp.UCALL = 671088644;
exports.ExCodeOp.UJMP = 671088642;
exports.ExBinOp = {}/*types.Enum*/;
exports.ExBinOp.XCHG = 67108866;
exports.ExBinOp.CMP = 67108868;
exports.ExBinOp.ADD = 67108872;
exports.ExBinOp.SUB = 67108880;
exports.ExBinOp.MUL = 67108928;
exports.ExBinOp.DIV = 67108992;
exports.ExBinOp.SHR = 67109120;
exports.ExBinOp.SHL = 67109376;
exports.ExBinOp.SAL = 67109888;
exports.ExBinOp.SAR = 67110912;
exports.ExBinOp.OR = 67112960;
exports.ExBinOp.AND = 67125248;
exports.ExBinOp.XOR = 67141632;
exports.ExBinOp.NOT = 67174400;
exports.ExBinOp.MOD = 67239936;
exports.ExBinOp.ROR = 67371008;
exports.ExBinOp.ROL = 67633152;
exports.ExObjOp = {}/*types.Enum*/;
exports.ExObjOp.CAST = 8388609;
exports.ExObjOp.CHECK = 8388610;
exports.ExObjOp.NEW = 8388612;
exports.ExObjOp.DEL = 8388616;
exports.ExObjOp.SIZE = 8388624;
exports.ExLdStOp = {}/*types.Enum*/;
exports.ExLdStOp.FROM_REF = 2;
exports.ExLdStOp.FROM_MEM = 2;
exports.ExLdStOp.FROM_REG = 4;
exports.ExLdStOp.FROM_STACK = 8;
exports.ExLdStOp.FROM_CONST = 16;
exports.ExLdStOp.FROM_VAR = 32;
exports.ExLdStOp.INDIRECT_REF = 64;
exports.ExLdStOp.INDIRECT_MEM = 64;
exports.ExLdStOp.INDIRECT_REG = 128;
exports.ExLdStOp.INDIRECT_STACK = 256;
exports.ExLdStOp.INDIRECT_IDX = 512;
exports.ExLdStOp.INDIRECT_VAR = 1024;
exports.ExLdStOp.TO_REF = 2048;
exports.ExLdStOp.TO_MEM = 2048;
exports.ExLdStOp.TO_REG = 4096;
exports.ExLdStOp.TO_STACK = 8192;
exports.ExLdStOp.TO_VAR = 16384;
exports.ExLdStOp.OP_PUSH = 32768;
exports.ExLdStOp.OP_POP = 65536;
exports.ExLdStOp.OP_MOV = 131072;
exports.ExLdStOp.OP_EFF_ADDR = 262144;
exports.ExLdStOp.OP_UPOP = 536936448;
exports.ExLdStOp.OP_UPUSH = 536903680;
exports.ExLdStOp.LOAD_FROM_CONST_REF_TO_STACK = 2138134;
exports.ExLdStOp.LOAD_FROM_CONST_TO_STACK = 2138128;
exports.ExLdStOp.LOAD_FROM_CONST_INDIRECT_TO_STACK = 2138640;
exports.ExLdStOp.LOAD_FROM_VAR_INDIRECT_TO_STACK = 2138656;
exports.ExLdStOp.LOAD_FROM_VAR_INDIRECT_TO_STACK_REF = 2138656;
exports.ExLdStOp.LOAD_FROM_VAR_TO_STACK = 2138656;
exports.ExLdStOp.LOAD_FROM_VAR_TO_STACK_REF = 2138656;
exports.ExLdStOp.LOAD_FROM_REF_INDIRECT_TO_STACK = 2138626;
exports.ExLdStOp.LOAD_FROM_REF_INDIRECT_TO_STACK_REF = 2138626;
exports.ExLdStOp.STORE_FROM_STACK_INDIRECT_TO_VAR = 1098248;
exports.ExLdStOp.STORE_FROM_STACK_INDIRECT_TO_VAR_REF = 1098248;
exports.ExLdStOp.STORE_FROM_STACK_TO_VAR = 1097736;
exports.ExLdStOp.STORE_FROM_STACK_TO_VAR_REF = 1097736;
exports.ExLdStOp.STORE_FROM_STACK_INDIRECT_TO_REF = 1083400;
exports.ExLdStOp.STORE_FROM_STACK_INDIRECT_TO_REF_REF = 1083400;
exports.ExLdStOp.LOAD_FROM_REF_TO_STACK = 2138130;
exports.ExLdStOp.LOAD_FROM_PRIM_VAR_TO_STACK = 2129968;
exports.ExLdStOp.LOAD_GET_STATIC = 2138118;
exports.ExLdStOp.STORE_PUT_STATIC = 1116172;
exports.ExLdStOp.LOAD_GET_FIELD = 2138118;
exports.ExLdStOp.STORE_PUT_FIELD = 1116172;
exports.ExFmt = {}/*types.Enum*/;
exports.ExFmt.EXEC = 0;
exports.ExFmt.DATA = 1;
exports.ExFmt.MIXED = 2;
exports.RConfigNodeType = {}/*types.Enum*/;
exports.RConfigNodeType.BOOL = 1;
exports.RConfigNodeType.INT = 2;
exports.RConfigNodeType.OFFT = 4;
exports.RConfigNodeType.STR = 8;
exports.RConfigNodeType.RO = 16;
exports.RConfigNodeType.RW = 32;
exports.RAnal.Cnd.EQ = 0;
exports.RAnal.Cnd.NE = 1;
exports.RAnal.Cnd.GE = 2;
exports.RAnal.Cnd.GT = 3;
exports.RAnal.Cnd.LE = 4;
exports.RAnal.Cnd.LT = 5;
exports.RAnal.Cnd.AL = 6;
exports.RAnal.Cnd.NV = 7;
exports.RAnal.FunctionType.NULL = 0;
exports.RAnal.FunctionType.FCN = 1;
exports.RAnal.FunctionType.LOC = 2;
exports.RAnal.FunctionType.SYM = 4;
exports.RAnal.FunctionType.IMP = 8;
exports.RAnal.BlockType.NULL = 0;
exports.RAnal.BlockType.HEAD = 1;
exports.RAnal.BlockType.BODY = 2;
exports.RAnal.BlockType.LAST = 4;
exports.RAnal.BlockType.FOOT = 8;
exports.RAnal.BlockType.SWITCH = 16;
exports.RAnal.BlockType.RET = 32;
exports.RAnal.BlockType.JMP = 64;
exports.RAnal.BlockType.COND = 256;
exports.RAnal.BlockType.CALL = 512;
exports.RAnal.BlockType.CMP = 1024;
exports.RAnal.BlockType.LD = 2048;
exports.RAnal.BlockType.ST = 4096;
exports.RAnal.BlockType.BINOP = 8192;
exports.RAnal.BlockType.TAIL = 32768;
exports.RAnal.BlockDiff.NULL = 0;
exports.RAnal.BlockDiff.MATCH = 109;
exports.RAnal.BlockDiff.UNMATCH = 117;
exports.RAnal.ReflineType.STYLE = 1;
exports.RAnal.ReflineType.WIDE = 2;
exports.RAnal.Ret.ERROR = -1;
exports.RAnal.Ret.DUP = -2;
exports.RAnal.Ret.NEW = -3;
exports.RAnal.Ret.END = -4;
exports.RAnal.Stack.NULL = 0;
exports.RAnal.Stack.NOP = 1;
exports.RAnal.Stack.INC = 2;
exports.RAnal.Stack.GET = 3;
exports.RAnal.Stack.SET = 4;
exports.RAnal.Data.NULL = 0;
exports.RAnal.Data.HEX = 1;
exports.RAnal.Data.STR = 2;
exports.RAnal.Data.CODE = 3;
exports.RAnal.Data.FUN = 4;
exports.RAnal.Data.STRUCT = 5;
exports.RAnal.Data.LAST = 6;
exports.RAnal.OpFamily.UNKNOWN = 0;
exports.RAnal.OpFamily.CPU = 1;
exports.RAnal.OpFamily.FPU = 2;
exports.RAnal.OpFamily.MMX = 3;
exports.RAnal.OpFamily.PRIV = 4;
exports.RAnal.OpFamily.LAST = 5;
exports.RAnal.VarDir.NONE = 0;
exports.RAnal.VarDir.IN = 256;
exports.RAnal.VarDir.OUT = 512;
exports.RAnal.OpType.NULL = 0;
exports.RAnal.OpType.JMP = 1;
exports.RAnal.OpType.UJMP = 2;
exports.RAnal.OpType.CJMP = -2147483647;
exports.RAnal.OpType.CALL = 3;
exports.RAnal.OpType.UCALL = 4;
exports.RAnal.OpType.REP = 1073741824;
exports.RAnal.OpType.RET = 5;
exports.RAnal.OpType.ILL = 6;
exports.RAnal.OpType.UNK = 7;
exports.RAnal.OpType.NOP = 8;
exports.RAnal.OpType.MOV = 9;
exports.RAnal.OpType.TRAP = 10;
exports.RAnal.OpType.SWI = 11;
exports.RAnal.OpType.UPUSH = 12;
exports.RAnal.OpType.PUSH = 13;
exports.RAnal.OpType.POP = 14;
exports.RAnal.OpType.CMP = 15;
exports.RAnal.OpType.ADD = 16;
exports.RAnal.OpType.SUB = 17;
exports.RAnal.OpType.MUL = 19;
exports.RAnal.OpType.DIV = 20;
exports.RAnal.OpType.SHR = 21;
exports.RAnal.OpType.SHL = 22;
exports.RAnal.OpType.OR = 25;
exports.RAnal.OpType.AND = 26;
exports.RAnal.OpType.XOR = 27;
exports.RAnal.OpType.NOT = 28;
exports.RAnal.OpType.STORE = 29;
exports.RAnal.OpType.LOAD = 30;
exports.RAnal.OpType.LEA = 31;
exports.RAnal.OpType.LEAVE = 32;
exports.RAnal.OpType.ROR = 33;
exports.RAnal.OpType.ROL = 34;
exports.RAnal.OpType.XCHG = 35;
exports.RAnal.OpType.MOD = 36;
exports.RAnal.OpType.SWITCH = 37;
exports.RAnal.MetaWhere.PREV = -1;
exports.RAnal.MetaWhere.HERE = 0;
exports.RAnal.MetaWhere.NEXT = 1;
exports.RAnal.MetaType.ANY = -1;
exports.RAnal.MetaType.DATA = 100;
exports.RAnal.MetaType.CODE = 99;
exports.RAnal.MetaType.STRING = 115;
exports.RAnal.MetaType.COMMENT = 67;
exports.RReg.Type.GPR = 0;
exports.RReg.Type.DRX = 1;
exports.RReg.Type.FPU = 2;
exports.RReg.Type.MMX = 3;
exports.RReg.Type.XMM = 4;
exports.RReg.Type.FLG = 5;
exports.RReg.Type.SEG = 6;
exports.RReg.Type.LAST = 7;
exports.RReg.Type.ALL = -1;
exports.RHash.Algorithm.ALL = 65535;
exports.RHash.Algorithm.MD5 = 1;
exports.RHash.Algorithm.SHA1 = 2;
exports.RHash.Algorithm.SHA256 = 4;
exports.RHash.Algorithm.SHA384 = 8;
exports.RHash.Algorithm.SHA512 = 16;
exports.RHash.Size.MD4 = 16;
exports.RHash.Size.MD5 = 16;
exports.RHash.Size.SHA1 = 20;
exports.RHash.Size.SHA256 = 32;
exports.RHash.Size.SHA384 = 48;
exports.RHash.Size.SHA512 = 64;
exports.RAsm.Arch.NONE = 0;
exports.RAsm.Arch.X86 = 1;
exports.RAsm.Arch.ARM = 2;
exports.RAsm.Arch.PPC = 4;
exports.RAsm.Arch.M68K = 8;
exports.RAsm.Arch.JAVA = 16;
exports.RAsm.Arch.MIPS = 32;
exports.RAsm.Arch.SPARC = 64;
exports.RAsm.Arch.CSR = 128;
exports.RAsm.Arch.MSIL = 256;
exports.RAsm.Arch.OBJD = 512;
exports.RAsm.Arch.BF = 1024;
exports.RAsm.Arch.SH = 2048;
exports.RAsm.Arch.Z80 = 16384;
exports.RAsm.Arch.I8080 = 65536;
exports.RAsm.Arch.ARC = 32768;
exports.RAsm.Syntax.NONE = 0;
exports.RAsm.Syntax.INTEL = 1;
exports.RAsm.Syntax.ATT = 2;
exports.RAsm.Mod.RAWVALUE = 114;
exports.RAsm.Mod.VALUE = 118;
exports.RAsm.Mod.DSTREG = 100;
exports.RAsm.Mod.SRCREG0 = 48;
exports.RAsm.Mod.SRCREG1 = 49;
exports.RAsm.Mod.SRCREG2 = 50;
exports.RIO.Perm.READ = 4;
exports.RIO.Perm.WRITE = 2;
exports.RIO.Perm.EXEC = 1;
exports.RIO.Seek.SET = 0;
exports.RIO.Seek.CUR = 1;
exports.RIO.Seek.END = 2;
exports.RBreakpoint.Protection.READ = 1;
exports.RBreakpoint.Protection.WRITE = 2;
exports.RBreakpoint.Protection.EXEC = 4;
exports.RBreakpoint.Type.SW = 0;
exports.RBreakpoint.Type.HW = 1;
exports.RBreakpoint.Type.COND = 2;
exports.RDebug.ProcessStatus.STOP = 115;
exports.RDebug.ProcessStatus.RUN = 114;
exports.RDebug.ProcessStatus.SLEEP = 83;
exports.RDebug.ProcessStatus.ZOMBIE = 122;
exports.RDebug.ProcessStatus.DEAD = 100;
exports.RDebug.Reason.NEW_PID = 1;
exports.RDebug.Reason.NEW_TID = 2;
exports.RDebug.Reason.NEW_LIB = 3;
exports.RDebug.Reason.EXIT_PID = 4;
exports.RDebug.Reason.EXIT_TID = 5;
exports.RDebug.Reason.EXIT_LIB = 6;
exports.RDebug.Reason.TRAP = 7;
exports.RDebug.Reason.ILL = 8;
exports.RDebug.Reason.SIGNAL = 10;
exports.RDebug.Reason.FPU = 11;
exports.RDebug.Reason.BP = 12;
exports.RDebug.Reason.UNKNOWN = 0;
exports.RSearch.Mode.KEYWORD = 0;
exports.RSearch.Mode.REGEXP = 1;
exports.RSearch.Mode.PATTERN = 2;
exports.RSearch.Mode.STRING = 3;
exports.RSearch.Mode.XREFS = 4;
exports.RSearch.Mode.AES = 5;
exports.RBin.Sym.ENTRY = 0;
exports.RBin.Sym.INIT = 1;
exports.RBin.Sym.MAIN = 2;
exports.RBin.Sym.FINI = 3;
exports.RBin.Sym.LAST = 4;
exports.RBin.RelocType._8 = 0;
exports.RBin.RelocType._16 = 1;
exports.RBin.RelocType._32 = 2;
exports.RBin.RelocType._64 = 3;
